/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/html/common/html",["require","exports","vs/editor/common/modes/modesRegistry","vs/editor/common/modes/supports","vs/base/common/arrays","vs/platform/platform","vs/platform/instantiation/common/descriptors","vs/base/common/winjs.base","vs/editor/common/modes","vs/editor/common/modes/abstractMode","vs/editor/common/modes/abstractState","vs/platform/thread/common/threadService"],function(e,t,n,r,o,i,s,a,c,l,u,d){!function(e){e[e.Content=0]="Content",e[e.OpeningStartTag=1]="OpeningStartTag",e[e.OpeningEndTag=2]="OpeningEndTag",e[e.WithinDoctype=3]="WithinDoctype",e[e.WithinTag=4]="WithinTag",e[e.WithinComment=5]="WithinComment",e[e.WithinEmbeddedContent=6]="WithinEmbeddedContent",e[e.AttributeName=7]="AttributeName",e[e.AttributeValue=8]="AttributeValue"}(t.States||(t.States={}));var h=t.States,p=["script","style"],m=function(e){function t(t,n,r,o,i,s,a){e.call(this,t),this.kind=n,this.lastTagName=r,this.lastAttributeName=o,this.embeddedContentType=i,this.attributeValueQuote=s,this.attributeValue=a}return __extends(t,e),t.escapeTagName=function(e){return"tag.html.tag-"+e.replace(/[:_]/g,"-")},t.prototype.makeClone=function(){return new t(this.getMode(),this.kind,this.lastTagName,this.lastAttributeName,this.embeddedContentType,this.attributeValueQuote,this.attributeValue)},t.prototype.equals=function(n){return n instanceof t?e.prototype.equals.call(this,n)&&this.kind===n.kind&&this.lastTagName===n.lastTagName&&this.lastAttributeName===n.lastAttributeName&&this.embeddedContentType===n.embeddedContentType&&this.attributeValueQuote===n.attributeValueQuote&&this.attributeValue===n.attributeValue:!1},t.prototype.nextName=function(e){return e.advanceIfRegExp(/^[_:\w][_:\w-.\d]*/).toLowerCase()},t.prototype.tokenize=function(e){switch(this.kind){case h.WithinComment:if(e.advanceUntilString2("-->",!1))return{type:"comment.html.content"};if(e.advanceIfString2("-->"))return this.kind=h.Content,{type:"comment.html",bracket:c.Bracket.Close};break;case h.WithinDoctype:if(e.advanceUntilString2(">",!1))return{type:"metatag.content.html"};if(e.advanceIfString2(">"))return this.kind=h.Content,{type:"metatag.html",bracket:c.Bracket.Close};break;case h.Content:if(e.advanceIfCharCode2("<".charCodeAt(0))){if(!e.eos()&&"!"===e.peek()){if(e.advanceIfString2("!--"))return this.kind=h.WithinComment,{type:"comment.html",bracket:c.Bracket.Open};if(e.advanceIfStringCaseInsensitive2("!DOCTYPE"))return this.kind=h.WithinDoctype,{type:"metatag.html",bracket:c.Bracket.Open}}return e.advanceIfCharCode2("/".charCodeAt(0))?(this.kind=h.OpeningEndTag,{type:"delimiter.end.html",bracket:c.Bracket.Open}):(this.kind=h.OpeningStartTag,{type:"delimiter.start.html",bracket:c.Bracket.Open})}break;case h.OpeningEndTag:var n=this.nextName(e);return n.length>0?{type:t.escapeTagName(n)}:e.advanceIfString2(">")?(this.kind=h.Content,{type:"delimiter.end.html",bracket:c.Bracket.Close}):(e.advanceUntilString2(">",!1),{type:""});case h.OpeningStartTag:if(this.lastTagName=this.nextName(e),this.lastTagName.length>0)return this.lastAttributeName=null,("script"===this.lastTagName||"style"===this.lastTagName)&&(this.lastAttributeName=null,this.embeddedContentType=null),this.kind=h.WithinTag,{type:t.escapeTagName(this.lastTagName)};break;case h.WithinTag:if(e.skipWhitespace2()||e.eos())return{type:""};var r=this.nextName(e);return r.length>0?(this.lastAttributeName=r,this.kind=h.AttributeName,{type:"attribute.name.html"}):e.advanceIfString2("/>")?(this.kind=h.Content,{type:"delimiter.start.html",bracket:c.Bracket.Close}):e.advanceIfCharCode2(">".charCodeAt(0))?-1!==p.indexOf(this.lastTagName)?(this.kind=h.WithinEmbeddedContent,{type:"delimiter.start.html",bracket:c.Bracket.Close}):(this.kind=h.Content,{type:"delimiter.start.html",bracket:c.Bracket.Close}):(e.next2(),{type:""});case h.AttributeName:return e.skipWhitespace2()||e.eos()?{type:""}:e.advanceIfCharCode2("=".charCodeAt(0))?(this.kind=h.AttributeValue,{type:"delimiter.assign.html"}):(this.kind=h.WithinTag,this.tokenize(e));case h.AttributeValue:if(e.eos())return{type:""};if(e.skipWhitespace2())return'"'===this.attributeValueQuote||"'"===this.attributeValueQuote?{type:"attribute.value.html"}:{type:""};if('"'!==this.attributeValueQuote&&"'"!==this.attributeValueQuote){var o=e.peek();return"'"===o||'"'===o?(this.attributeValueQuote=o,this.attributeValue=o,e.next2(),{type:"attribute.value.html"}):(this.kind=h.WithinTag,this.tokenize(e))}if(this.attributeValue!==this.attributeValueQuote||"script"!==this.lastTagName&&"style"!==this.lastTagName||"type"!==this.lastAttributeName){if(e.advanceIfCharCode2(this.attributeValueQuote.charCodeAt(0)))this.kind=h.WithinTag,this.attributeValue="",this.attributeValueQuote="";else{var i=e.next();this.attributeValue+=i}return{type:"attribute.value.html"}}if(this.attributeValue=e.advanceUntilString(this.attributeValueQuote,!0),this.attributeValue.length>0)return this.embeddedContentType=this.unquote(this.attributeValue),this.kind=h.WithinTag,this.attributeValue="",this.attributeValueQuote="",{type:"attribute.value.html"}}return e.next2(),this.kind=h.Content,{type:""}},t.prototype.unquote=function(e){var t=0,n=e.length;return'"'===e[0]&&t++,'"'===e[n-1]&&n--,e.substring(t,n)},t}(u.AbstractState);t.State=m;var f=function(e){function t(t,n,o,i){var a=this;void 0===i&&(i=s.AsyncDescriptor.create("vs/languages/html/common/htmlWorker","HTMLWorker")),e.call(this,t,n,o,i),this.modeService=t.modeService,this.tokenizationSupport=new r.TokenizationSupport(this,this,!0,!0),this.electricCharacterSupport=new r.BracketElectricCharacterSupport(this,{brackets:[],regexBrackets:[{tokenType:"tag.html.tag-$1",open:/<(?!(?:area|base|basefont|br|col|command|embed|frame|hr|img|input|link|meta|param|source|track|wbr))(\w[\w\d]*)([^\/>]*(?!\/)>)[^<]*$/i,closeComplete:"</$1>",close:/<\/(\w[\w\d]*)\s*>$/i}],caseInsensitive:!0,embeddedElectricCharacters:["*","}","]",")"]}),this.formattingSupport=this,this.extraInfoSupport=this,this.referenceSupport=new r.ReferenceSupport(this,{tokens:["invalid"],findReferences:function(e,t,n){return a.findReferences(e,t,n)}}),this.logicalSelectionSupport=this,this.parameterHintsSupport=new r.ParameterHintsSupport(this,{triggerCharacters:["(",","],excludeTokens:["*"],getParameterHints:function(e,t){return a.getParameterHints(e,t)}}),this.suggestSupport=new r.SuggestSupport(this,{triggerCharacters:[".",":","<",'"',"=","/"],excludeTokens:["comment"],suggest:function(e,t){return a.suggest(e,t)}})}return __extends(t,e),t.prototype.asyncCtor=function(){var e=this;return a.Promise.join([this.modeService.getOrCreateMode("text/javascript"),this.modeService.getOrCreateMode("text/css")]).then(function(t){var n=e._getAutoClosingPairs(t);e.characterPairSupport=new r.CharacterPairSupport(e,{autoClosingPairs:n.slice(0),surroundingPairs:[{open:'"',close:'"'},{open:"'",close:"'"}]})})},t.prototype._getAutoClosingPairs=function(e){var t=this,n={'"':'"',"'":"'"};e.forEach(function(e){return t._collectAutoClosingPairs(n,e)});var r,o=[];for(r in n)o.push({open:r,close:n[r]});return o},t.prototype._collectAutoClosingPairs=function(e,t){if(t&&t.characterPairSupport){var n=t.characterPairSupport.getAutoClosingPairs();if(null!==n)for(var r=0;r<n.length;r++)e[n[r].open]=n[r].close}},t.prototype.getInitialState=function(){return new m(this,h.Content,"","","","","")},t.prototype.enterNestedMode=function(e){return e instanceof m&&e.kind===h.WithinEmbeddedContent},t.prototype.getNestedMode=function(e){var t=null,n=e,r=null;if(null!==n.embeddedContentType)g.isRegisteredMode(n.embeddedContentType)&&(t=this.modeService.getMode(n.embeddedContentType),t||(r=this.modeService.getOrCreateMode(n.embeddedContentType)));else{var o=null;o="script"===n.lastTagName?"text/javascript":"style"===n.lastTagName?"text/css":"text/plain",t=this.modeService.getMode(o)}return null===t&&(t=this.modeService.getMode("text/plain")),{mode:t,missingModePromise:r}},t.prototype.getLeavingNestedModeData=function(e,t){var n=t.lastTagName,r=new RegExp("<\\/"+n+"\\s*>","i"),o=r.exec(e);return null!==o?{nestedModeBuffer:e.substring(0,o.index),bufferAfterNestedMode:e.substring(o.index),stateAfterNestedMode:new m(this,h.Content,"","","","","")}:null},t.prototype.getWordDefinition=function(){return t.WORD_DEFINITION},t.prototype.getCommentsConfiguration=function(){return{blockCommentStartToken:"<!--",blockCommentEndToken:"-->"}},t.prototype._worker=function(t){return e.prototype._worker.call(this,t)},t.prototype.formatDocument=function(e,t){return this._worker(function(n){return n.format(e,null,t)})},t.prototype.formatRange=function(e,t,n){return this._worker(function(r){return r.format(e,t,n)})},t.prototype.computeInfo=function(e,t){return this._delegateToModeAtPosition(e,t,function(e,n){return e&&n.getMode().extraInfoSupport?n.getMode().extraInfoSupport.computeInfo(n.getAssociatedResource(),t):void 0})},t.prototype.findReferences=function(e,t,n){return this._delegateToModeAtPosition(e,t,function(e,r){return e&&r.getMode().referenceSupport?r.getMode().referenceSupport.findReferences(r.getAssociatedResource(),t,n):void 0})},t.prototype.getRangesToPosition=function(e,t){return this._delegateToModeAtPosition(e,t,function(e,n){return e&&n.getMode().logicalSelectionSupport?n.getMode().logicalSelectionSupport.getRangesToPosition(n.getAssociatedResource(),t):void 0})},t.prototype.findDeclaration=function(e,t){return this._delegateToModeAtPosition(e,t,function(e,n){return e&&n.getMode().declarationSupport?n.getMode().declarationSupport.findDeclaration(n.getAssociatedResource(),t):void 0})},t.prototype.findOccurrences=function(e,t,n){var r=this;return void 0===n&&(n=!1),this._delegateToModeAtPosition(e,t,function(o,i){return o&&i.getMode().occurrencesSupport?i.getMode().occurrencesSupport.findOccurrences(i.getAssociatedResource(),t,n):r._worker(function(r){return r.findOccurrences(e,t,n)})})},t.prototype.suggest=function(e,t){var n=this;return this._delegateToModeAtPosition(e,t,function(r,o){return r&&o.getMode().suggestSupport?o.getMode().suggestSupport.suggest(o.getAssociatedResource(),t).then(function(e){var n=o.getMode().getId();if("javascript"===n||"css"===n){var r=o.getLineContent(t.lineNumber).substring(0,t.column-1).match(l.createWordRegExp("</")),i="</"+("javascript"===n?"script":"style")+">";e.push({currentWord:r?r[r.length-1]:"",suggestions:[{label:i,codeSnippet:i,type:"property"}]})}return e}):n._worker(function(n){return n.suggest(e,t)})})},t.prototype.findColorDeclarations=function(e){return this._delegateToAllModes(e,function(e){var t=[];return t=e.filter(function(e){return"function"==typeof e.getMode().findColorDeclarations}).map(function(e){return e.getMode().findColorDeclarations(e.getAssociatedResource())}),a.TPromise.join(t).then(function(e){var t=[];return e.forEach(function(e){return t=t.concat(e)}),t})})},t.prototype.getParameterHints=function(e,t){return this._delegateToModeAtPosition(e,t,function(e,n){return e&&n.getMode().parameterHintsSupport?n.getMode().parameterHintsSupport.getParameterHints(n.getAssociatedResource(),t):void 0})},t.WORD_DEFINITION=l.createWordRegExp("#-?%"),t.$formatDocument=d.OneWorkerAttr(t,t.prototype.formatDocument),t.$formatRange=d.OneWorkerAttr(t,t.prototype.formatRange),t.$computeInfo=d.OneWorkerAttr(t,t.prototype.computeInfo),t.$findReferences=d.OneWorkerAttr(t,t.prototype.findReferences),t.$getRangesToPosition=d.OneWorkerAttr(t,t.prototype.getRangesToPosition),t.$findDeclaration=d.OneWorkerAttr(t,t.prototype.findDeclaration),t.$findOccurrences=d.OneWorkerAttr(t,t.prototype.findOccurrences),t.$suggest=d.OneWorkerAttr(t,t.prototype.suggest),t.$findColorDeclarations=d.OneWorkerAttr(t,t.prototype.findColorDeclarations),t.$getParameterHints=d.OneWorkerAttr(t,t.prototype.getParameterHints),t}(l.AbstractMode);t.HTMLMode=f;var g=i.Registry.as(n.Extensions.EditorModes)});