/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/json/common/parser/jsonParser",["require","exports","vs/nls!vs/languages/json/common/jsonWorker","vs/base/common/arrays","vs/base/common/types","vs/base/common/json"],function(e,t,n,r,o,i){var s=function(){function e(e,t,n,r,o){this.type=t,this.name=n,this.start=r,this.end=o,this.parent=e}return e.prototype.getPath=function(){var e=[];return this.parent?(e=this.parent.getPath(),this.name&&e.push(this.name),e):e},e.prototype.getChildNodes=function(){return[]},e.prototype.getValue=function(){},e.prototype.contains=function(e,t){return void 0===t&&(t=!1),e>=this.start&&e<this.end||t&&e===this.end},e.prototype.visit=function(e){return e(this)},e.prototype.getNodeFromOffset=function(e){var t=function(n){if(e>=n.start&&e<n.end){for(var r=n.getChildNodes(),o=0;o<r.length&&r[o].start<=e;o++){var i=t(r[o]);if(i)return i}return n}return null};return t(this)},e.prototype.getNodeFromOffsetEndInclusive=function(e){var t=function(n){if(e>=n.start&&e<=n.end){for(var r=n.getChildNodes(),o=0;o<r.length&&r[o].start<=e;o++){var i=t(r[o]);if(i)return i}return n}return null};return t(this)},e.prototype.validate=function(e,t,o,i){var s=this;if(void 0===i&&(i=-1),-1===i||this.contains(i)){if(Array.isArray(e.type)?r.contains(e.type,this.type)===!1?t.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",0,e.type.join())}):e.type.length>0&&(t.typeMatch=!0):e.type&&(this.type!==e.type?t.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",1,e.type)}):t.typeMatch=!0),Array.isArray(e.allOf)&&e.allOf.forEach(function(e){s.validate(e,t,o,i)}),e.not){var a=new f,c=[];this.validate(e.not,a,c,i),a.hasErrors()||t.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",2)}),o&&c.forEach(function(e){e.inverted=!e.inverted,o.push(e)})}var l=function(e,r){var i=0,a=null;return e.forEach(function(e){var t=new f,n=[];if(s.validate(e,t,n),t.hasErrors()||i++,a)if(r||t.hasErrors()||a.validationResult.hasErrors()){var o=t.compare(a.validationResult);o>0?a={schema:e,validationResult:t,matchingSchemas:n}:0===o&&a.matchingSchemas.push.apply(a.matchingSchemas,n)}else a.matchingSchemas.push.apply(a.matchingSchemas,n),a.validationResult.propertiesMatches+=t.propertiesMatches,a.validationResult.propertiesValueMatches+=t.propertiesValueMatches;else a={schema:e,validationResult:t,matchingSchemas:n}}),i>1&&r&&t.warnings.push({location:{start:s.start,end:s.start+1},message:n.localize("vs_languages_json_common_parser_jsonParser",3)}),null!==a&&(t.merge(a.validationResult),t.propertiesMatches+=a.validationResult.propertiesMatches,t.propertiesValueMatches+=a.validationResult.propertiesValueMatches,o&&o.push.apply(o,a.matchingSchemas)),i};Array.isArray(e.anyOf)&&l(e.anyOf,!1),Array.isArray(e.oneOf)&&l(e.oneOf,!0),Array.isArray(e.enum)&&r.contains(e.enum,this.getValue())===!1&&t.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",4,JSON.stringify(e.enum))}),null!==o&&o.push({node:this,schema:e})}},e}();t.ASTNode=s;var a=function(e){function t(t,n,r,o){e.call(this,t,"null",n,r,o)}return __extends(t,e),t.prototype.getValue=function(){return null},t}(s);t.NullASTNode=a;var c=function(e){function t(t,n,r,o,i){e.call(this,t,"boolean",n,o,i),this.value=r}return __extends(t,e),t.prototype.getValue=function(){return this.value},t}(s);t.BooleanASTNode=c;var l=function(e){function t(t,n,r,o){e.call(this,t,"array",n,r,o),this.items=[]}return __extends(t,e),t.prototype.getChildNodes=function(){return this.items},t.prototype.getValue=function(){return this.items.map(function(e){return e.getValue()})},t.prototype.addItem=function(e){return e?(this.items.push(e),!0):!1},t.prototype.visit=function(e){for(var t=e(this),n=0;n<this.items.length&&t;n++)t=this.items[n].visit(e);return t},t.prototype.validate=function(t,r,o,i){var s=this;if(void 0===i&&(i=-1),-1===i||this.contains(i)){if(e.prototype.validate.call(this,t,r,o,i),Array.isArray(t.items)){var a=t.items;a.forEach(function(e,n){var a=new f,c=s.items[n];c?(c.validate(e,a,o,i),r.mergePropertyMatch(a)):s.items.length>=t.items.length&&r.propertiesValueMatches++}),t.additionalItems===!1&&this.items.length>a.length?r.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",5,a.length)}):this.items.length>=t.items.length&&(r.propertiesValueMatches+=this.items.length-t.items.length)}else t.items&&this.items.forEach(function(e){var n=new f;e.validate(t.items,n,o,i),r.mergePropertyMatch(n)});if(t.minItems&&this.items.length<t.minItems&&r.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",6,t.minItems)}),t.maxItems&&this.items.length>t.maxItems&&r.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",7,t.minItems)}),t.uniqueItems===!0){var c=this.items.map(function(e){return e.getValue()}),l=c.some(function(e,t){return t!==c.lastIndexOf(e)});l&&r.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",8)})}}},t}(s);t.ArrayASTNode=l;var u=function(e){function t(t,n,r,o){e.call(this,t,"number",n,r,o),this.isInteger=!0,this.value=Number.NaN}return __extends(t,e),t.prototype.getValue=function(){return this.value},t.prototype.validate=function(t,i,s,a){if(void 0===a&&(a=-1),-1===a||this.contains(a)){var c=!1;("integer"===t.type||Array.isArray(t.type)&&r.contains(t.type,"integer"))&&(c=!0),c&&this.isInteger===!0&&(this.type="integer"),e.prototype.validate.call(this,t,i,s,a),this.type="number";var l=this.getValue();o.isNumber(t.multipleOf)&&l%t.multipleOf!==0&&i.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",9,t.multipleOf)}),o.isUndefined(t.minimum)||(t.exclusiveMinimum&&l<=t.minimum&&i.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",10,t.minimum)}),!t.exclusiveMinimum&&l<t.minimum&&i.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",11,t.minimum)})),o.isUndefined(t.maximum)||(t.exclusiveMaximum&&l>=t.maximum&&i.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",12,t.maximum)}),!t.exclusiveMaximum&&l>t.maximum&&i.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",13,t.maximum)}))}},t}(s);t.NumberASTNode=u;var d=function(e){function t(t,n,r,o,i){this.isKey=r,this.value="",e.call(this,t,"string",n,o,i)}return __extends(t,e),t.prototype.getValue=function(){return this.value},t.prototype.validate=function(t,r,o,i){if(void 0===i&&(i=-1),(-1===i||this.contains(i))&&(e.prototype.validate.call(this,t,r,o,i),t.minLength&&this.value.length<t.minLength&&r.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",14,t.minLength)}),t.maxLength&&this.value.length>t.maxLength&&r.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",15,t.maxLength)}),t.pattern)){var s=new RegExp(t.pattern);s.test(this.value)||r.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",16,t.pattern)})}},t}(s);t.StringASTNode=d;var h=function(e){function t(t,n){e.call(this,t,"property",null,n.start),this.key=n,n.parent=this,n.name=n.value,this.colonOffset=-1}return __extends(t,e),t.prototype.getChildNodes=function(){return this.value?[this.key,this.value]:[this.key]},t.prototype.setValue=function(e){return this.value=e,null!==e},t.prototype.visit=function(e){return e(this)&&this.key.visit(e)&&this.value&&this.value.visit(e)},t.prototype.validate=function(e,t,n,r){void 0===r&&(r=-1),(-1===r||this.contains(r))&&this.value&&this.value.validate(e,t,n,r)},t}(s);t.PropertyASTNode=h;var p=function(e){function t(t,n,r,o){e.call(this,t,"object",n,r,o),this.properties=[]}return __extends(t,e),t.prototype.getChildNodes=function(){return this.properties},t.prototype.addProperty=function(e){return e?(this.properties.push(e),!0):!1},t.prototype.getFirstProperty=function(e){for(var t=0;t<this.properties.length;t++)if(this.properties[t].key.value===e)return this.properties[t];return null},t.prototype.getKeyList=function(){return this.properties.map(function(e){return e.key.getValue()})},t.prototype.getValue=function(){var e={};return this.properties.forEach(function(t){var n=t.value&&t.value.getValue();n&&(e[t.key.getValue()]=n)}),e},t.prototype.visit=function(e){for(var t=e(this),n=0;n<this.properties.length&&t;n++)t=this.properties[n].visit(e);return t},t.prototype.validate=function(t,r,i,s){var a=this;if(void 0===s&&(s=-1),-1===s||this.contains(s)){e.prototype.validate.call(this,t,r,i,s);var c={},l=[];this.properties.forEach(function(e){var t=e.key.value;c[t]=e.value,l.push(t)}),Array.isArray(t.required)&&t.required.forEach(function(e){if(!c[e]){var t=a.parent&&a.parent&&a.parent.key,o=t?{start:t.start,end:t.end}:{start:a.start,end:a.start+1};r.warnings.push({location:o,message:n.localize("vs_languages_json_common_parser_jsonParser",17,e)})}});var u=function(e){for(var t=l.indexOf(e);t>=0;)l.splice(t,1),t=l.indexOf(e)};t.properties&&Object.keys(t.properties).forEach(function(e){u(e);var n=t.properties[e],o=c[e];if(o){var a=new f;o.validate(n,a,i,s),r.mergePropertyMatch(a)}}),t.patternProperties&&Object.keys(t.patternProperties).forEach(function(e){var n=new RegExp(e);l.slice(0).forEach(function(o){if(n.test(o)){u(o);var a=c[o];if(a){var l=new f;a.validate(t.patternProperties[e],l,i,s),r.mergePropertyMatch(l)}}})}),o.isObject(t.additionalProperties)?l.forEach(function(e){var n=c[e];if(n){var o=new f;n.validate(t.additionalProperties,o,i,s),r.mergePropertyMatch(o)}}):t.additionalProperties===!1&&l.length>0&&l.forEach(function(e){var t=c[e];if(t){var o=t.parent;r.warnings.push({location:{start:o.key.start,end:o.key.end},message:n.localize("vs_languages_json_common_parser_jsonParser",18,e)})}}),t.maxProperties&&this.properties.length>t.maxProperties&&r.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",19,t.maxProperties)}),t.minProperties&&this.properties.length<t.minProperties&&r.warnings.push({location:{start:this.start,end:this.end},message:n.localize("vs_languages_json_common_parser_jsonParser",20,t.minProperties)}),o.isObject(t.dependencies)&&Object.keys(t.dependencies).forEach(function(e){var l=c[e];if(l)if(Array.isArray(t.dependencies[e])){var u=t.dependencies[e];u.forEach(function(t){c[t]?r.propertiesValueMatches++:r.warnings.push({location:{start:a.start,end:a.end},message:n.localize("vs_languages_json_common_parser_jsonParser",21,t,e)})})}else if(o.isObject(t.dependencies[e])){var d=t.dependencies[e],h=new f;a.validate(d,h,i,s),r.mergePropertyMatch(h)}})}},t}(s);t.ObjectASTNode=p;var m=function(){function e(){this.ignoreDanglingComma=!1}return e}();t.JSONDocumentConfig=m;var f=function(){function e(){this.errors=[],this.warnings=[],this.propertiesMatches=0,this.propertiesValueMatches=0,this.typeMatch=!1}return e.prototype.hasErrors=function(){return!!this.errors.length||!!this.warnings.length},e.prototype.mergeAll=function(e){var t=this;e.forEach(function(e){t.merge(e)})},e.prototype.merge=function(e){this.errors=this.errors.concat(e.errors),this.warnings=this.warnings.concat(e.warnings)},e.prototype.mergePropertyMatch=function(e){this.merge(e),this.propertiesMatches++,e.hasErrors()||this.propertiesValueMatches++},e.prototype.compare=function(e){var t=this.hasErrors();return t!==e.hasErrors()?t?-1:1:this.typeMatch!==e.typeMatch?e.typeMatch?-1:1:this.propertiesValueMatches!==e.propertiesValueMatches?this.propertiesValueMatches-e.propertiesValueMatches:this.propertiesMatches-e.propertiesMatches},e}();t.ValidationResult=f;var g=function(){function e(e){this.config=e,this.validationResult=new f}return Object.defineProperty(e.prototype,"errors",{get:function(){return this.validationResult.errors},set:function(e){this.validationResult.errors=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"warnings",{get:function(){return this.validationResult.warnings},set:function(e){this.validationResult.warnings=e},enumerable:!0,configurable:!0}),e.prototype.getNodeFromOffset=function(e){return this.root&&this.root.getNodeFromOffset(e)},e.prototype.getNodeFromOffsetEndInclusive=function(e){return this.root&&this.root.getNodeFromOffsetEndInclusive(e)},e.prototype.visit=function(e){this.root&&this.root.visit(e)},e.prototype.validate=function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=-1),this.root&&this.root.validate(e,this.validationResult,t,n)},e}();t.JSONDocument=g;var v=function(){function e(){}return e.prototype.parse=function(e,t){function r(e){return T.getToken()===e?(T.scan(),!0):!1}function o(e,t,n,r){if(void 0===t&&(t=null),void 0===n&&(n=[]),void 0===r&&(r=[]),0===x.errors.length||x.errors[0].location.start!==T.getTokenOffset()){var o={message:e,location:{start:T.getTokenOffset(),end:T.getTokenOffset()+T.getTokenLength()}};x.errors.push(o)}if(t&&f(t,!1),n.length+r.length>0)for(var s=T.getToken();s!==i.SyntaxKind.EOF;){if(-1!==n.indexOf(s)){T.scan();break}if(-1!==r.indexOf(s))break;s=T.scan()}return t}function s(){switch(T.getTokenError()){case i.ScanError.InvalidUnicode:return o(n.localize("vs_languages_json_common_parser_jsonParser",22)),!0;case i.ScanError.InvalidEscapeCharacter:return o(n.localize("vs_languages_json_common_parser_jsonParser",23)),!0;case i.ScanError.UnexpectedEndOfNumber:return o(n.localize("vs_languages_json_common_parser_jsonParser",24)),!0;case i.ScanError.UnexpectedEndOfComment:return o(n.localize("vs_languages_json_common_parser_jsonParser",25)),!0;case i.ScanError.UnexpectedEndOfString:return o(n.localize("vs_languages_json_common_parser_jsonParser",26)),!0}return!1}function f(e,t){return e.end=T.getTokenOffset()+T.getTokenLength(),t&&T.scan(),e}function v(e,t){if(T.getToken()!==i.SyntaxKind.OpenBracketToken)return null;var s=new l(e,t,T.getTokenOffset());T.scan();var a=0;if(s.addItem(k(s,""+a++)))for(;r(i.SyntaxKind.CommaToken);)s.addItem(k(s,""+a++))||x.config.ignoreDanglingComma||o(n.localize("vs_languages_json_common_parser_jsonParser",27));return T.getToken()!==i.SyntaxKind.CloseBracketToken?o(n.localize("vs_languages_json_common_parser_jsonParser",28),s):f(s,!0)}function b(e,t){var r=_(null,null,!0);if(!r){if(T.getToken()===i.SyntaxKind.Unknown){var s=T.getTokenValue();s.length>0&&("'"===s.charAt(0)||i.isLetter(s.charAt(0).charCodeAt(0)))&&o(n.localize("vs_languages_json_common_parser_jsonParser",29))}return null}var a=new h(e,r);return t[r.value]&&x.warnings.push({location:{start:a.key.start,end:a.key.end},message:n.localize("vs_languages_json_common_parser_jsonParser",30)}),t[r.value]=!0,T.getToken()!==i.SyntaxKind.ColonToken?o(n.localize("vs_languages_json_common_parser_jsonParser",31),a,[],[i.SyntaxKind.CloseBraceToken,i.SyntaxKind.CommaToken]):(a.colonOffset=T.getTokenOffset(),T.scan(),a.setValue(k(a,a.key.getValue()))?(a.end=a.value.end,a):o(n.localize("vs_languages_json_common_parser_jsonParser",32),a,[],[i.SyntaxKind.CloseBraceToken,i.SyntaxKind.CommaToken]))}function y(e,t){if(T.getToken()!==i.SyntaxKind.OpenBraceToken)return null;var s=new p(e,t,T.getTokenOffset());T.scan();var a={};if(s.addProperty(b(s,a)))for(;r(i.SyntaxKind.CommaToken);)s.addProperty(b(s,a))||x.config.ignoreDanglingComma||o(n.localize("vs_languages_json_common_parser_jsonParser",33));return T.getToken()!==i.SyntaxKind.CloseBraceToken?o(n.localize("vs_languages_json_common_parser_jsonParser",34),s):f(s,!0)}function _(e,t,n){if(T.getToken()!==i.SyntaxKind.StringLiteral)return null;var r=new d(e,t,n,T.getTokenOffset());return r.value=T.getTokenValue(),s(),f(r,!0)}function w(e,t){if(T.getToken()!==i.SyntaxKind.NumericLiteral)return null;var r=new u(e,t,T.getTokenOffset());if(!s()){var a=T.getTokenValue();try{var c=JSON.parse(a);if("number"!=typeof c)return o(n.localize("vs_languages_json_common_parser_jsonParser",35),r);r.value=c}catch(l){return o(n.localize("vs_languages_json_common_parser_jsonParser",36),r)}r.isInteger=-1===a.indexOf(".")}return f(r,!0)}function S(e,t){var n;switch(T.getToken()){case i.SyntaxKind.NullKeyword:n=new a(e,t,T.getTokenOffset());break;case i.SyntaxKind.TrueKeyword:n=new c(e,t,!0,T.getTokenOffset());break;case i.SyntaxKind.FalseKeyword:n=new c(e,t,!1,T.getTokenOffset());break;default:return null}return f(n,!0)}function k(e,t){return v(e,t)||y(e,t)||_(e,t,!1)||w(e,t)||S(e,t)}void 0===t&&(t=new m);var x=new g(t),T=i.createScanner(e,!0);return T.scan(),x.root=k(null,"root"),x.root?T.getToken()!==i.SyntaxKind.EOF&&o(n.localize("vs_languages_json_common_parser_jsonParser",38)):o(n.localize("vs_languages_json_common_parser_jsonParser",37)),x},e}();t.JSONParser=v}),define("vs/languages/json/common/features/jsonFormatter",["require","exports","vs/base/common/json"],function(e,t,n){function r(e,t,r){function s(){return e.getEOL()+o(h,l+m)}function a(){var e=f.scan();for(p=!1;e===n.SyntaxKind.Trivia||e===n.SyntaxKind.LineBreakTrivia;)p=p||e===n.SyntaxKind.LineBreakTrivia,e=f.scan();return e}function c(t,n){e.getValueInRange(n)!==t&&g.push({range:n,text:t})}var l,u,d;t?(t={startLineNumber:t.startLineNumber,startColumn:1,endLineNumber:t.endLineNumber,endColumn:e.getLineMaxColumn(t.endLineNumber)},l=i(e.getLineContent(t.startLineNumber),r),u=e.getValueInRange(t),d=e.getOffsetFromPosition({lineNumber:t.startLineNumber,column:t.startColumn})):(t=e.getFullModelRange(),l=0,u=e.getValue(),d=0);var h,p=!1,m=0;h=r.insertSpaces?o(" ",r.tabSize):"	";var f=n.createScanner(u,!1),g=[],v=a();if(v!==n.SyntaxKind.EOF){var b=e.getPositionFromOffset(f.getTokenOffset()+d),y=o(h,l);c(y,{startLineNumber:t.startLineNumber,startColumn:t.startColumn,endLineNumber:b.lineNumber,endColumn:b.column})}for(;v!==n.SyntaxKind.EOF;){for(var _=e.getPositionFromOffset(f.getTokenOffset()+f.getTokenLength()+d),w=a();!p&&(w===n.SyntaxKind.LineCommentTrivia||w===n.SyntaxKind.BlockCommentTrivia);){var S=e.getPositionFromOffset(f.getTokenOffset()+d);c(" ",{startLineNumber:_.lineNumber,startColumn:_.column,endLineNumber:S.lineNumber,endColumn:S.column}),_=e.getPositionFromOffset(f.getTokenOffset()+f.getTokenLength()+d),w=a()}var k="";if(w===n.SyntaxKind.CloseBraceToken)v!==n.SyntaxKind.OpenBraceToken&&(m--,k=s());else if(w===n.SyntaxKind.CloseBracketToken)v!==n.SyntaxKind.OpenBracketToken&&(m--,k=s());else{switch(v){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:m++,k=s();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:k=s();break;case n.SyntaxKind.BlockCommentTrivia:k=p?s():" ";break;case n.SyntaxKind.ColonToken:k=" ";break;case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:(w===n.SyntaxKind.NullKeyword||w===n.SyntaxKind.FalseKeyword||w===n.SyntaxKind.NumericLiteral)&&(k=" ")}!p||w!==n.SyntaxKind.LineCommentTrivia&&w!==n.SyntaxKind.BlockCommentTrivia||(k=s())}var x=e.getPositionFromOffset(f.getTokenOffset()+d);c(k,{startLineNumber:_.lineNumber,startColumn:_.column,endLineNumber:x.lineNumber,endColumn:x.column}),v=w}return g}function o(e,t){for(var n="",r=0;t>r;r++)n+=e;return n}function i(e,t){for(var n=0,r=0,o=t.tabSize||4;n<e.length;){var i=e.charAt(n);if(" "===i)r++;else{if("	"!==i)break;r+=o}n++}return Math.floor(r/o)}t.format=r}),define("vs/languages/json/common/jsonSchemaService",["require","exports","vs/nls!vs/languages/json/common/jsonWorker","vs/base/common/objects","vs/base/common/strings","vs/base/common/types","vs/base/common/winjs.base","vs/editor/common/services/resourceService"],function(e,t,n,r,o,i,s,a){function c(e,t){for(var n=function(e,t){if(!t)return e;var n=e;return t.substr(1).split("/").some(function(e){return n=n[e],!n}),n||{}},o=function(r){var o=r.split("#",2);if(o[0].length>0)return t?t(o[0]).then(function(e){return n(e,o[1])}):s.TPromise.as({});var i=n(e,o[1]);return s.TPromise.as(i)},a=[{parent:null,key:null,value:e}],c=[];a.length;){var l=a.pop();if(Array.isArray(l.value))l.value.forEach(function(e,t){a.push({parent:l.value,key:t,value:e})});else if(i.isObject(l.value))if(l.value.$ref){var u=o(l.value.$ref).then(function(e){r.mixin(l.value,e,!1),delete l.value.$ref});c.push(u)}else Object.keys(l.value).forEach(function(e){a.push({parent:l.value,key:e,value:l.value[e]})})}return s.TPromise.join(c).then(function(){return new d(e)})}var l=function(){function e(e,t){this.url=e,this.filePatterns=t}return e.prototype.matchesPattern=function(e){for(var t=0;t<this.filePatterns.length;t++)if(this.filePatterns[t].test(e))return!0;return!1},e}(),u=function(){function e(e,t,n){void 0===n&&(n=null),this.service=e,this.url=t,this.schema=null,n&&(this.schema=c(n))}return e.prototype.getSchema=function(){return null===this.schema&&(this.schema=this.service.fetchFileSchema(this.url)),this.schema},e.prototype.clearSchema=function(){this.schema=null},e}(),d=function(){function e(e,t){void 0===t&&(t=null),this.schema=e,this.loadError=t}return e.prototype.getSection=function(e){return this.getSectionRecursive(e,this.schema)},e.prototype.getSectionRecursive=function(e,t){var n=this;if(!t||0===e.length)return t;var r=e.shift();if(t.properties&&t.properties[r])return this.getSectionRecursive(e,t.properties[r]);if(i.isObject(t.patternProperties))Object.keys(t.patternProperties).forEach(function(o){var i=new RegExp(o);return i.test(r)?n.getSectionRecursive(e,t.patternProperties[o]):void 0});else{if(i.isObject(t.additionalProperties))return this.getSectionRecursive(e,t.additionalProperties);if(r.match("[0-9]+")){if(i.isObject(t.items))return this.getSectionRecursive(e,t.items);if(Array.isArray(t.items))try{var o=parseInt(r,10);return t.items[o]?this.getSectionRecursive(e,t.items[o]):null}catch(s){return null}}}return null},e}();t.FileSchema=d;var h=function(){function e(e){var t=this;this.snippetSchema=new d({default:{"{{snippetName}}":{prefix:"{{prefix}}",body:"{{snippet}}",description:"{{description}}"}},type:"object",description:n.localize("vs_languages_json_common_jsonSchemaService",0),additionalProperties:{type:"object",required:["prefix","body"],properties:{prefix:{description:n.localize("vs_languages_json_common_jsonSchemaService",1),type:"string"},body:{description:n.localize("vs_languages_json_common_jsonSchemaService",2),type:["string","array"],items:{type:"string"}},description:{description:n.localize("vs_languages_json_common_jsonSchemaService",3),type:"string"}},additionalProperties:!1}}),this.requestService=e.requestService,this.contextService=e.contextService,this.callOnDispose=[];var r=e.resourceService;r&&this.callOnDispose.push(r.addListener_(a.ResourceEvents.CHANGED,function(e){return t.onResourceChange(e)})),this.configurationSchemas={},this.preloadedSchemas={},this.schemasById={},this.schemasFilePatternMapping=[],this.addPreloadedFileSchemas()}return e.prototype.dispose=function(){for(;this.callOnDispose.length>0;)this.callOnDispose.pop()()},e.prototype.onResourceChange=function(e){var t=e.url.toString(),n=this.schemasById[t];n&&n.clearSchema()},e.prototype.setConfigurationSchemas=function(e){var t=this,n={};e.forEach(function(e){n[e.id]=e});var r=function(e){return s.Promise.as(n[e])};e.forEach(function(e){t.configurationSchemas[e.id]=c(e,r)})},e.prototype.registerExternalSchema=function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=null);var r=new u(this,e,n);return this.schemasById[e]=r,t&&t.length>0&&this.schemasFilePatternMapping.push(new l(e,t)),r},e.prototype.clearExternalSchemas=function(){this.schemasById={},this.schemasFilePatternMapping=[]},e.prototype.getConfigurationSchema=function(e){return this.configurationSchemas[e]||s.TPromise.as(null)},e.prototype.fetchFileSchema=function(e){var t=this.preloadedSchemas[e];return t?t:this.requestService.makeRequest({url:e}).then(function(e){return e.responseText}).then(function(e){var t=null;try{t=JSON.parse(e)}catch(n){}return t?c(t):null},function(t){var r=n.localize("vs_languages_json_common_jsonSchemaService",4,e,t.statusText||t.toString());return console.log(r),new d({},r)})},e.prototype.getSchemaForResource=function(e,t){if(o.endsWith(e.toLowerCase(),"/user/settings.json"))return this.getConfigurationSchema("local://configuration/user/settings");if("inmemory:/.settings/defaults.json"===e)return this.getConfigurationSchema("local://configuration/default/settings");if("inmemory:/.keybindings/defaults.json"===e||o.endsWith(e.toLowerCase(),"/user/keybindings.json"))return this.getConfigurationSchema("local://configuration/user/keybindings");if(e.match(/\/User\/snippets\/[^\/\.]+\.json$/i))return s.TPromise.as(this.snippetSchema);var n="/.settings/",r=".json",i=e.indexOf(n);if(-1!==i&&o.endsWith(e,r)){var a=e.substring(i+n.length,e.length-r.length);return this.getConfigurationSchema("local://configuration/workspace/"+a)}if(t&&t.root&&"object"===t.root.type){var c=t.root.properties.filter(function(e){return"$schema"===e.key.value&&!!e.value});if(c.length>0){var l=c[0].value.getValue();if(!o.startsWith(l,"http://")&&!o.startsWith(l,"https://")&&!o.startsWith(l,"file://")){var u=this.contextService.toResource(l);u&&(l=u.toString())}if(l){var d=this.schemasById[l];return d?d.getSchema():this.registerExternalSchema(l).getSchema()}}}for(var h=this.schemasFilePatternMapping.length-1;h>=0;h--){var p=this.schemasFilePatternMapping[h];if(p.matchesPattern(e)){var m=this.schemasById[p.url];if(m)return m.getSchema()}}return s.TPromise.as(null)},e.prototype.addPreloadedFileSchema=function(e,t){this.preloadedSchemas[e]=c(t)},e.prototype.addPreloadedFileSchemas=function(){this.addPreloadedFileSchema("http://json-schema.org/draft-04/schema#",{id:"http://json-schema.org/draft-04/schema#",title:n.localize("vs_languages_json_common_jsonSchemaService",5),$schema:"http://json-schema.org/draft-04/schema#",definitions:{schemaArray:{type:"array",minItems:1,items:{$ref:"#"}},positiveInteger:{type:"integer",minimum:0},positiveIntegerDefault0:{allOf:[{$ref:"#/definitions/positiveInteger"},{default:0}]},simpleTypes:{type:"string",enum:["array","boolean","integer","null","number","object","string"]},stringArray:{type:"array",items:{type:"string"},minItems:1,uniqueItems:!0}},type:"object",properties:{id:{type:"string",format:"uri",description:n.localize("vs_languages_json_common_jsonSchemaService",6)},$schema:{type:"string",format:"uri",description:n.localize("vs_languages_json_common_jsonSchemaService",7)},title:{type:"string",description:n.localize("vs_languages_json_common_jsonSchemaService",8)},description:{type:"string",description:n.localize("vs_languages_json_common_jsonSchemaService",9)},default:{description:n.localize("vs_languages_json_common_jsonSchemaService",10)},multipleOf:{type:"number",minimum:0,exclusiveMinimum:!0,description:n.localize("vs_languages_json_common_jsonSchemaService",11)},maximum:{type:"number",description:n.localize("vs_languages_json_common_jsonSchemaService",12)},exclusiveMaximum:{type:"boolean",default:!1,description:n.localize("vs_languages_json_common_jsonSchemaService",13)},minimum:{type:"number",description:n.localize("vs_languages_json_common_jsonSchemaService",14)},exclusiveMinimum:{type:"boolean",default:!1,description:n.localize("vs_languages_json_common_jsonSchemaService",15)},maxLength:{allOf:[{$ref:"#/definitions/positiveInteger"}],description:n.localize("vs_languages_json_common_jsonSchemaService",16)},minLength:{allOf:[{$ref:"#/definitions/positiveIntegerDefault0"}],description:n.localize("vs_languages_json_common_jsonSchemaService",17)},pattern:{type:"string",format:"regex",description:n.localize("vs_languages_json_common_jsonSchemaService",18)},additionalItems:{anyOf:[{type:"boolean"},{$ref:"#"}],default:{},description:n.localize("vs_languages_json_common_jsonSchemaService",19)},items:{anyOf:[{$ref:"#"},{$ref:"#/definitions/schemaArray"}],default:{},description:n.localize("vs_languages_json_common_jsonSchemaService",20)},maxItems:{allOf:[{$ref:"#/definitions/positiveInteger"}],description:n.localize("vs_languages_json_common_jsonSchemaService",21)},minItems:{allOf:[{$ref:"#/definitions/positiveIntegerDefault0"}],description:n.localize("vs_languages_json_common_jsonSchemaService",22)},uniqueItems:{type:"boolean",default:!1,description:n.localize("vs_languages_json_common_jsonSchemaService",23)},maxProperties:{allOf:[{$ref:"#/definitions/positiveInteger"}],description:n.localize("vs_languages_json_common_jsonSchemaService",24)},minProperties:{allOf:[{$ref:"#/definitions/positiveIntegerDefault0"}],description:n.localize("vs_languages_json_common_jsonSchemaService",25)},required:{allOf:[{$ref:"#/definitions/stringArray"}],description:n.localize("vs_languages_json_common_jsonSchemaService",26)},additionalProperties:{anyOf:[{type:"boolean"},{$ref:"#"}],default:{},description:n.localize("vs_languages_json_common_jsonSchemaService",27)},definitions:{type:"object",additionalProperties:{$ref:"#"},default:{},description:n.localize("vs_languages_json_common_jsonSchemaService",28)},properties:{type:"object",additionalProperties:{$ref:"#"},default:{},description:n.localize("vs_languages_json_common_jsonSchemaService",29)},patternProperties:{type:"object",additionalProperties:{$ref:"#"},default:{},description:n.localize("vs_languages_json_common_jsonSchemaService",30)},dependencies:{type:"object",additionalProperties:{anyOf:[{$ref:"#"},{$ref:"#/definitions/stringArray"}]},description:n.localize("vs_languages_json_common_jsonSchemaService",31)},enum:{type:"array",minItems:1,uniqueItems:!0,description:n.localize("vs_languages_json_common_jsonSchemaService",32)},type:{anyOf:[{$ref:"#/definitions/simpleTypes"},{type:"array",items:{$ref:"#/definitions/simpleTypes"},minItems:1,uniqueItems:!0}],description:n.localize("vs_languages_json_common_jsonSchemaService",33)},allOf:{allOf:[{$ref:"#/definitions/schemaArray"}],description:n.localize("vs_languages_json_common_jsonSchemaService",34)},anyOf:{allOf:[{$ref:"#/definitions/schemaArray"}],description:n.localize("vs_languages_json_common_jsonSchemaService",35)},oneOf:{allOf:[{$ref:"#/definitions/schemaArray"}],description:n.localize("vs_languages_json_common_jsonSchemaService",36)},not:{allOf:[{$ref:"#"}],description:n.localize("vs_languages_json_common_jsonSchemaService",37)}},dependencies:{exclusiveMaximum:["maximum"],exclusiveMinimum:["minimum"]},default:{}}),this.addPreloadedFileSchema("http://json.schemastore.org/project",{title:n.localize("vs_languages_json_common_jsonSchemaService",38),$schema:"http://json-schema.org/draft-04/schema#",id:"http://json.schemastore.org/project",type:"object",definitions:{compilationOptions:{description:n.localize("vs_languages_json_common_jsonSchemaService",39),type:"object",properties:{define:{type:"array",items:{type:"string",uniqueItems:!0}},warningsAsErrors:{type:"boolean",default:!1},allowUnsafe:{type:"boolean",default:!1},optimize:{type:"boolean",default:!1},languageVersion:{type:"string",enum:["csharp1","csharp2","csharp3","csharp4","csharp5","csharp6","experimental"]}}},configType:{type:"object",properties:{dependencies:{$ref:"#/definitions/dependencies"},compilationOptions:{$ref:"#/definitions/compilationOptions"},frameworkAssemblies:{$ref:"#/definitions/dependencies"}}},dependencies:{type:"object",additionalProperties:{type:["string","object"],properties:{version:{type:"string",description:n.localize("vs_languages_json_common_jsonSchemaService",40)},type:{type:"string",default:"default",enum:["default","build"],description:n.localize("vs_languages_json_common_jsonSchemaService",41)}},id:"nugget-package"},description:n.localize("vs_languages_json_common_jsonSchemaService",42),id:"nugget-packages"},script:{type:["string","array"],items:{type:"string"},description:n.localize("vs_languages_json_common_jsonSchemaService",43)}},properties:{authors:{description:n.localize("vs_languages_json_common_jsonSchemaService",44),type:"array",items:{type:"string",uniqueItems:!0}},bundleExclude:{description:n.localize("vs_languages_json_common_jsonSchemaService",45),type:["string","array"],items:{type:"string"},default:""},code:{description:n.localize("vs_languages_json_common_jsonSchemaService",46),type:["string","array"],items:{type:"string"},default:"**\\*.cs"},commands:{description:n.localize("vs_languages_json_common_jsonSchemaService",47),type:"object",additionalProperties:{type:"string"}},compilationOptions:{$ref:"#/definitions/compilationOptions"},configurations:{type:"object",description:n.localize("vs_languages_json_common_jsonSchemaService",48),additionalProperties:{type:"object",properties:{compilationOptions:{$ref:"#/definitions/compilationOptions"}}}},dependencies:{$ref:"#/definitions/dependencies"},description:{description:n.localize("vs_languages_json_common_jsonSchemaService",49),type:"string"},exclude:{description:n.localize("vs_languages_json_common_jsonSchemaService",50),type:["string","array"],items:{type:"string"},default:["bin/**/*.*","obj/**/*.*"]},frameworks:{description:n.localize("vs_languages_json_common_jsonSchemaService",51),type:"object",additionalProperties:{$ref:"#/definitions/configType"}},preprocess:{description:n.localize("vs_languages_json_common_jsonSchemaService",52),type:"string",default:"Compiler\\Preprocess\\**\\*.cs"},resources:{description:n.localize("vs_languages_json_common_jsonSchemaService",53),type:["string","array"],items:{type:"string"},default:"Compiler\\Resources\\**\\*.cs"},scripts:{type:"object",description:n.localize("vs_languages_json_common_jsonSchemaService",54),properties:{prepack:{$ref:"#/definitions/script"},postpack:{$ref:"#/definitions/script"},prebundle:{$ref:"#/definitions/script"},postbundle:{$ref:"#/definitions/script"},prerestore:{$ref:"#/definitions/script"},postrestore:{$ref:"#/definitions/script"},prepare:{$ref:"#/definitions/script"}}},shared:{description:n.localize("vs_languages_json_common_jsonSchemaService",55),type:["string","array"],items:{type:"string"},default:"Compiler\\Shared\\**\\*.cs"},version:{description:n.localize("vs_languages_json_common_jsonSchemaService",56),type:"string"},webroot:{description:n.localize("vs_languages_json_common_jsonSchemaService",57),type:"string"}}}),this.addPreloadedFileSchema("http://json.schemastore.org/bower",{title:n.localize("vs_languages_json_common_jsonSchemaService",58),$schema:"http://json-schema.org/draft-04/schema#",id:"http://json.schemastore.org/bower",type:"object",required:["name"],patternProperties:{"^_":{description:n.localize("vs_languages_json_common_jsonSchemaService",59),additionalProperties:!0,additionalItems:!0}},properties:{name:{description:n.localize("vs_languages_json_common_jsonSchemaService",60),type:"string",maxLength:50},description:{description:n.localize("vs_languages_json_common_jsonSchemaService",61),type:"string"},version:{description:n.localize("vs_languages_json_common_jsonSchemaService",62),type:"string"},main:{description:n.localize("vs_languages_json_common_jsonSchemaService",63),type:["string","array"]},license:{description:n.localize("vs_languages_json_common_jsonSchemaService",64),type:["string","array"],maxLength:140},ignore:{description:n.localize("vs_languages_json_common_jsonSchemaService",65),type:["string","array"]},keywords:{description:n.localize("vs_languages_json_common_jsonSchemaService",66),type:"array",items:{type:"string",maxLength:50}},authors:{description:n.localize("vs_languages_json_common_jsonSchemaService",67),type:"array",items:{type:["string","object"]}},homepage:{description:n.localize("vs_languages_json_common_jsonSchemaService",68),type:"string"},repository:{description:n.localize("vs_languages_json_common_jsonSchemaService",69),type:"object",properties:{type:{type:"string",enum:["git"]},url:{type:"string"}}},dependencies:{id:"bower-packages",description:n.localize("vs_languages_json_common_jsonSchemaService",70),type:"object",additionalProperties:{id:"bower-package",type:"string"}},devDependencies:{id:"bower-packages",description:n.localize("vs_languages_json_common_jsonSchemaService",71),type:"object",additionalProperties:{id:"bower-package",type:"string"}},resolutions:{description:n.localize("vs_languages_json_common_jsonSchemaService",72),type:"object"},private:{description:n.localize("vs_languages_json_common_jsonSchemaService",73),type:"boolean"},exportsOverride:{description:n.localize("vs_languages_json_common_jsonSchemaService",74),type:"object",additionalProperties:{type:"object",additionalProperties:{type:"string"}}},moduleType:{description:n.localize("vs_languages_json_common_jsonSchemaService",75),type:"array",items:{enum:["amd","es6","globals","node","yui"]}}}}),this.addPreloadedFileSchema("http://json.schemastore.org/package",{id:"http://json.schemastore.org/package",description:n.localize("vs_languages_json_common_jsonSchemaService",76),type:"object",required:["name","version"],definitions:{person:{description:n.localize("vs_languages_json_common_jsonSchemaService",77),type:["object","string"],required:["name"],properties:{name:{type:"string"},url:{type:"string",format:"uri"},email:{type:"string",format:"email"}}},dependency:{id:"npm-packages",description:n.localize("vs_languages_json_common_jsonSchemaService",78),type:"object",additionalProperties:{type:"string"}}},patternProperties:{"^_":{description:n.localize("vs_languages_json_common_jsonSchemaService",79),additionalProperties:!0,additionalItems:!0}},properties:{name:{description:n.localize("vs_languages_json_common_jsonSchemaService",80),type:"string"},version:{description:n.localize("vs_languages_json_common_jsonSchemaService",81),type:"string"},description:{description:n.localize("vs_languages_json_common_jsonSchemaService",82),type:"string"},keywords:{description:n.localize("vs_languages_json_common_jsonSchemaService",83),type:"array"},homepage:{description:n.localize("vs_languages_json_common_jsonSchemaService",84),type:"string"},bugs:{description:n.localize("vs_languages_json_common_jsonSchemaService",85),type:["object","string"],properties:{url:{type:"string",description:n.localize("vs_languages_json_common_jsonSchemaService",86),format:"uri"},email:{type:"string",description:n.localize("vs_languages_json_common_jsonSchemaService",87)}}},license:{type:"string",description:n.localize("vs_languages_json_common_jsonSchemaService",88)},licenses:{description:n.localize("vs_languages_json_common_jsonSchemaService",89),type:"array",items:{type:"object",properties:{type:{type:"string"},url:{type:"string",format:"uri"}}}},author:{$ref:"#/definitions/person"},contributors:{description:n.localize("vs_languages_json_common_jsonSchemaService",90),type:"array",items:{$ref:"#/definitions/person"}},maintainers:{description:n.localize("vs_languages_json_common_jsonSchemaService",91),type:"array",items:{$ref:"#/definitions/person"}},files:{description:n.localize("vs_languages_json_common_jsonSchemaService",92),type:"array",items:{type:"string"}},main:{description:n.localize("vs_languages_json_common_jsonSchemaService",93),type:"string"},bin:{type:["string","object"],additionalProperties:{type:"string"}},man:{type:["array","string"],description:n.localize("vs_languages_json_common_jsonSchemaService",94),items:{type:"string"}},directories:{type:"object",properties:{bin:{description:n.localize("vs_languages_json_common_jsonSchemaService",95),type:"string"},doc:{description:n.localize("vs_languages_json_common_jsonSchemaService",96),type:"string"},example:{description:n.localize("vs_languages_json_common_jsonSchemaService",97),type:"string"},lib:{description:n.localize("vs_languages_json_common_jsonSchemaService",98),type:"string"},man:{description:n.localize("vs_languages_json_common_jsonSchemaService",99),type:"string"},test:{type:"string"}}},repository:{description:n.localize("vs_languages_json_common_jsonSchemaService",100),type:"object",properties:{type:{type:"string"},url:{type:"string"}}},scripts:{description:n.localize("vs_languages_json_common_jsonSchemaService",101),type:"object",additionalProperties:{type:"string"}},config:{description:n.localize("vs_languages_json_common_jsonSchemaService",102),type:"object",additionalProperties:!0},dependencies:{$ref:"#/definitions/dependency"},devDependencies:{$ref:"#/definitions/dependency"},bundleDependencies:{type:"array",description:n.localize("vs_languages_json_common_jsonSchemaService",103),items:{type:"string"}},bundledDependencies:{type:"array",description:n.localize("vs_languages_json_common_jsonSchemaService",104),items:{type:"string"}},optionalDependencies:{$ref:"#/definitions/dependency"},peerDependencies:{$ref:"#/definitions/dependency"},engines:{type:"object",additionalProperties:{type:"string"}},engineStrict:{type:"boolean"},os:{type:"array",items:{type:"string"}},cpu:{type:"array",items:{type:"string"}},preferGlobal:{type:"boolean",description:n.localize("vs_languages_json_common_jsonSchemaService",105)},private:{type:"boolean",description:n.localize("vs_languages_json_common_jsonSchemaService",106)},publishConfig:{type:"object",additionalProperties:!0},dist:{type:"object",properties:{shasum:{type:"string"},tarball:{type:"string"}}},readme:{type:"string"}}}),this.addPreloadedFileSchema("http://json.schemastore.org/global",{title:n.localize("vs_languages_json_common_jsonSchemaService",107),type:"object",additionalProperties:!0,required:["projects"],properties:{projects:{type:"array",description:n.localize("vs_languages_json_common_jsonSchemaService",108),items:{type:"string"}},sources:{type:"array",description:n.localize("vs_languages_json_common_jsonSchemaService",109),items:{type:"string"}}}}),this.addPreloadedFileSchema("http://json.schemastore.org/tsconfig",{title:n.localize("vs_languages_json_common_jsonSchemaService",110),$schema:"http://json-schema.org/draft-04/schema#",type:"object",default:{compilerOptions:{target:"ES5",module:"commonjs"}},properties:{compilerOptions:{type:"object",description:n.localize("vs_languages_json_common_jsonSchemaService",111),properties:{charset:{description:n.localize("vs_languages_json_common_jsonSchemaService",112),type:"string"},declaration:{description:n.localize("vs_languages_json_common_jsonSchemaService",113),type:"boolean"},diagnostics:{description:n.localize("vs_languages_json_common_jsonSchemaService",114),type:"boolean"},emitBOM:{description:n.localize("vs_languages_json_common_jsonSchemaService",115),type:"boolean"},inlineSourceMap:{description:n.localize("vs_languages_json_common_jsonSchemaService",116),type:"number"},inlineSources:{description:n.localize("vs_languages_json_common_jsonSchemaService",117),type:"number"},listFiles:{description:n.localize("vs_languages_json_common_jsonSchemaService",118),type:"boolean"},locale:{description:n.localize("vs_languages_json_common_jsonSchemaService",119),type:"string"},mapRoot:{description:n.localize("vs_languages_json_common_jsonSchemaService",120),type:"string",format:"uri"},module:{description:n.localize("vs_languages_json_common_jsonSchemaService",121),enum:["commonjs","amd"]},newLine:{description:n.localize("vs_languages_json_common_jsonSchemaService",122),type:"boolean"},noEmit:{description:n.localize("vs_languages_json_common_jsonSchemaService",123),type:"boolean"},noEmitOnError:{description:n.localize("vs_languages_json_common_jsonSchemaService",124),type:"boolean"},noEmitHelpers:{description:n.localize("vs_languages_json_common_jsonSchemaService",125),type:"boolean"},noImplicitAny:{description:n.localize("vs_languages_json_common_jsonSchemaService",126),type:"boolean"},noLib:{description:n.localize("vs_languages_json_common_jsonSchemaService",127),type:"boolean"},noResolve:{type:"boolean"},out:{description:n.localize("vs_languages_json_common_jsonSchemaService",128),type:"string",format:"uri"},outDir:{description:n.localize("vs_languages_json_common_jsonSchemaService",129),type:"string",format:"uri"},preserveConstEnums:{description:n.localize("vs_languages_json_common_jsonSchemaService",130),type:"boolean"},removeComments:{description:n.localize("vs_languages_json_common_jsonSchemaService",131),type:"boolean"},rootDir:{description:n.localize("vs_languages_json_common_jsonSchemaService",132),type:"boolean"},sourceMap:{description:n.localize("vs_languages_json_common_jsonSchemaService",133),type:"boolean"},sourceRoot:{description:n.localize("vs_languages_json_common_jsonSchemaService",134),type:"string",format:"uri"},suppressImplicitAnyIndexErrors:{description:n.localize("vs_languages_json_common_jsonSchemaService",135),type:"boolean"},target:{description:n.localize("vs_languages_json_common_jsonSchemaService",136),enum:["ES3","ES5","ES6","es3","es5","es6"],default:"ES3"}}},files:{type:"array",description:n.localize("vs_languages_json_common_jsonSchemaService",137),items:{type:"string",format:"uri"}}}}),this.addPreloadedFileSchema("http://opentools.azurewebsites.net/jsconfig",{title:n.localize("vs_languages_json_common_jsonSchemaService",138),type:"object",default:{compilerOptions:{target:"ES5"}},properties:{compilerOptions:{type:"object",description:n.localize("vs_languages_json_common_jsonSchemaService",139),properties:{charset:{description:n.localize("vs_languages_json_common_jsonSchemaService",140),type:"string"},diagnostics:{description:n.localize("vs_languages_json_common_jsonSchemaService",141),type:"boolean"},locale:{description:n.localize("vs_languages_json_common_jsonSchemaService",142),type:"string"},mapRoot:{description:n.localize("vs_languages_json_common_jsonSchemaService",143),type:"string",format:"uri"},module:{description:n.localize("vs_languages_json_common_jsonSchemaService",144),enum:["commonjs","amd","system","umd"]},noLib:{description:n.localize("vs_languages_json_common_jsonSchemaService",145),type:"boolean"},target:{description:n.localize("vs_languages_json_common_jsonSchemaService",146),enum:["ES3","ES5","ES6","es3","es5","es6"],default:"ES3"}}},files:{type:"array",description:n.localize("vs_languages_json_common_jsonSchemaService",147),items:{type:"string",format:"uri"}},exclude:{type:"array",description:n.localize("vs_languages_json_common_jsonSchemaService",148),items:{type:"string",format:"uri"}}}}),this.addPreloadedFileSchema("http://opentools.azurewebsites.net/ticino.plugin.json",{default:{pluginId:"{{}}",contributes:{language:[{id:"",extensions:[]}]}},properties:{pluginId:{description:n.localize("vs_languages_json_common_jsonSchemaService",149),type:"string"},activationEvents:{description:n.localize("vs_languages_json_common_jsonSchemaService",150),type:"array",items:{type:"string"}},dependencies:{description:n.localize("vs_languages_json_common_jsonSchemaService",151),type:"array",items:{type:"string"}},mainModule:{description:n.localize("vs_languages_json_common_jsonSchemaService",152),type:"string"},contributes:{description:n.localize("vs_languages_json_common_jsonSchemaService",153),type:"object",default:{language:[{id:"",extensions:[]}]},properties:{language:{description:n.localize("vs_languages_json_common_jsonSchemaService",154),type:"array",default:[{id:"",extensions:[]}],items:{type:"object",default:{id:"",extensions:[]},properties:{id:{description:n.localize("vs_languages_json_common_jsonSchemaService",155),type:"string"},extensions:{description:n.localize("vs_languages_json_common_jsonSchemaService",156),type:"array",items:{type:"string"}},filenames:{description:n.localize("vs_languages_json_common_jsonSchemaService",157),default:[".foo"],type:"array",items:{type:"string"}},aliases:{description:n.localize("vs_languages_json_common_jsonSchemaService",158),type:"array",items:{type:"string"}}}}}}},scripts:{description:n.localize("vs_languages_json_common_jsonSchemaService",159),type:"object",properties:{compile:{description:n.localize("vs_languages_json_common_jsonSchemaService",160),type:"string"}}}}})
},e}();t.JSONSchemaService=h}),define("vs/languages/json/common/jsonIntellisense",["require","exports","./parser/jsonParser","vs/base/common/types","vs/base/common/winjs.base","vs/nls!vs/languages/json/common/jsonWorker","vs/base/common/errors"],function(e,t,n,r,o,i,s){var a=function(){function e(e,t){this.schemaService=e.schemaService,this.requestService=e.requestService,this.contributions=t}return e.prototype.doSuggest=function(e,t,r){var i=this,a=t.getWordUntilPosition(r).word,c=new n.JSONParser,l=new n.JSONDocumentConfig;l.ignoreDanglingComma=!0;var u=c.parse(t.getValue(),l),d={currentWord:a,incomplete:!1,suggestions:[]},h={},p={add:function(e){h[e.label]||(h[e.label]=!0,d.suggestions.push(e))},setAsIncomplete:function(){d.incomplete=!0},error:function(e){s.onUnexpectedError(e)}};return this.schemaService.getSchemaForResource(e.toString(),u).then(function(e){var n=[],s=t.getOffsetFromPosition(r),c=u.getNodeFromOffsetEndInclusive(s),l=!0,h=a;if(c&&"string"===c.type){var m=c;if(m.isKey){var f=t.getRangeFromOffsetAndLength(c.start,c.end-c.start);d.overwriteBefore=r.column-f.startColumn,d.overwriteAfter=f.endColumn-r.column,l=!(c.parent&&c.parent.value),h=t.getValueInRange({startColumn:f.startColumn+1,startLineNumber:f.startLineNumber,endColumn:r.column,endLineNumber:r.lineNumber}),c.parent&&(c=c.parent.parent)}}if(c&&"object"===c.type){if(c.start===s)return d;if(e){var g=c.properties,v=0===g.length||s>=g[g.length-1].start;n.push(i.getPropertySuggestions(e,u,c,h,l,v,p))}else c.parent&&n.push(i.getSchemaLessPropertySuggestions(u,c,p))}if(c&&("string"===c.type||"number"===c.type||"boolean"===c.type||"null"===c.type)){var f=t.getRangeFromOffsetAndLength(c.start,c.end-c.start);d.overwriteBefore=r.column-f.startColumn,d.overwriteAfter=f.endColumn-r.column,c=c.parent}return e?n.push(i.getValueSuggestions(e,u,c,s,p)):n.push(i.getSchemaLessValueSuggestions(u,c,s,t,p)),o.Promise.join(n).then(function(){return d})})},e.prototype.getPropertySuggestions=function(e,t,n,r,i,s,a){var c=this,l=[];t.validate(e.schema,l,n.start);var u=[];return l.forEach(function(e){if(e.node===n&&!e.inverted){var t=e.schema.properties;t&&Object.keys(t).forEach(function(e){var n=t[e];a.add({type:"property",label:e,codeSnippet:c.getSnippetForProperty(e,n,i,s),documentationLabel:n.description||""})});var o=e.schema.id;o&&c.contributions.forEach(function(e){u.push(e.collectPropertySuggestions(o,r,i,s,a))})}}),o.Promise.join(u)},e.prototype.getSchemaLessPropertySuggestions=function(e,t,n){var r=this,i=function(e){e.properties.forEach(function(e){var t=e.key.value;n.add({type:"property",label:t,codeSnippet:r.getSnippetForSimilarProperty(t,e.value),documentationLabel:""})})};if("property"===t.parent.type){var s=t.parent.key.value;e.visit(function(e){return"property"===e.type&&e.key.value===s&&e.value&&"object"===e.value.type&&i(e.value),!0})}else"array"===t.parent.type&&t.parent.items.forEach(function(e){"object"===e.type&&e!==t&&i(e)});return o.Promise.as(0)},e.prototype.getSchemaLessValueSuggestions=function(e,t,n,r,i){var s=this,a=function(e){var t=s.getMatchingSnippet(e,r);i.add({type:s.getSuggestionType(e.type),label:t,codeSnippet:t,documentationLabel:""}),"boolean"===e.type&&s.addBooleanSuggestion(!e.getValue(),i)};if(t){if("property"===t.type&&n>t.colonOffset){var c=t.value;if(c&&n>c.end)return;var l=t.key.value;e.visit(function(e){return"property"===e.type&&e.key.value===l&&e.value&&a(e.value),!0})}if("array"===t.type)if(t.parent&&"property"===t.parent.type){var l=t.parent.key.value;e.visit(function(e){return"property"===e.type&&e.key.value===l&&e.value&&"array"===e.value.type&&e.value.items.forEach(function(e){a(e)}),!0})}else t.items.forEach(function(e){a(e)})}else i.add({type:this.getSuggestionType("object"),label:"Empty object",codeSnippet:"{\n	{{}}\n}",documentationLabel:""}),i.add({type:this.getSuggestionType("array"),label:"Empty array",codeSnippet:"[\n	{{}}\n]",documentationLabel:""});return o.Promise.as(0)},e.prototype.getValueSuggestions=function(e,t,n,r,i){var s=this,a=[];if(n){var c=null;if(n&&"property"===n.type&&r>n.colonOffset){var l=n.value;if(l&&r>l.end)return o.Promise.as(0);c=n.key.value,n=n.parent}if(n&&(null!==c||"array"===n.type)){var u=[];t.validate(e.schema,u,n.start),u.forEach(function(e){if(e.node===n&&!e.inverted&&e.schema){if(e.schema.items&&(s.addDefaultSuggestion(e.schema.items,i),s.addEnumSuggestion(e.schema.items,i)),e.schema.properties){var t=e.schema.properties[c];t&&(s.addDefaultSuggestion(t,i),s.addEnumSuggestion(t,i))}var r=e.schema.id;r&&s.contributions.forEach(function(e){a.push(e.collectValueSuggestions(r,c,i))})}})}}else this.addDefaultSuggestion(e.schema,i),this.contributions.forEach(function(t){a.push(t.collectDefaultSuggestions(e.schema.id,i))});return o.Promise.join(a)},e.prototype.addBooleanSuggestion=function(e,t){t.add({type:this.getSuggestionType("boolean"),label:e?"true":"false",codeSnippet:this.getSnippetForValue(e),documentationLabel:""})},e.prototype.addEnumSuggestion=function(e,t){var n=this;Array.isArray(e.enum)?e.enum.forEach(function(r){return t.add({type:n.getSuggestionType(e.type),label:n.getLabelForValue(r),codeSnippet:n.getSnippetForValue(r),documentationLabel:""})}):"boolean"===e.type&&(this.addBooleanSuggestion(!0,t),this.addBooleanSuggestion(!1,t)),Array.isArray(e.allOf)&&e.allOf.forEach(function(e){return n.addEnumSuggestion(e,t)}),Array.isArray(e.anyOf)&&e.anyOf.forEach(function(e){return n.addEnumSuggestion(e,t)}),Array.isArray(e.oneOf)&&e.oneOf.forEach(function(e){return n.addEnumSuggestion(e,t)})},e.prototype.addDefaultSuggestion=function(e,t){var n=this;e.default&&t.add({type:this.getSuggestionType(e.type),label:this.getLabelForValue(e.default),codeSnippet:this.getSnippetForValue(e.default),typeLabel:i.localize("vs_languages_json_common_jsonIntellisense",0)}),Array.isArray(e.allOf)&&e.allOf.forEach(function(e){return n.addDefaultSuggestion(e,t)}),Array.isArray(e.anyOf)&&e.anyOf.forEach(function(e){return n.addDefaultSuggestion(e,t)}),Array.isArray(e.oneOf)&&e.oneOf.forEach(function(e){return n.addDefaultSuggestion(e,t)})},e.prototype.getLabelForValue=function(e){var t=JSON.stringify(e);return t=t.replace("{{","").replace("}}",""),t.length>57?t.substr(0,57).trim()+"...":t},e.prototype.getSnippetForValue=function(e){var t=JSON.stringify(e,null,"	");switch(typeof e){case"object":return null===e?"{{null}}":t;case"string":return'"{{'+t.substr(1,t.length-2)+'}}"';case"number":case"boolean":return"{{"+t+"}}"}return t},e.prototype.getSuggestionType=function(e){if(Array.isArray(e)){var t=e;e=t.length>0?t[0]:null}if(!e)return"text";switch(e){case"string":return"text";case"object":return"module";case"property":return"property";default:return"value"}},e.prototype.getMatchingSnippet=function(e,t){switch(e.type){case"array":return"[]";case"object":return"{}";default:var n=t.getValueInRange(t.getRangeFromOffsetAndLength(e.start,e.end-e.start));return n}},e.prototype.getSnippetForProperty=function(e,t,n,o){var i='"'+e+'"';if(!n)return i;i+=": ";var s=t.default;if(r.isUndefined(s))if(t.enum&&t.enum.length>0)i+=this.getSnippetForValue(t.enum[0]);else switch(t.type){case"boolean":i+="{{false}}";break;case"string":i+='"{{}}"';break;case"object":i+="{\n	{{}}\n}";break;case"array":i+="[\n	{{}}\n]";break;case"number":i+="{{0}}";break;case"null":i+="{{null}}";break;default:return i}else i+=this.getSnippetForValue(s);return o||(i+=","),i},e.prototype.getSnippetForSimilarProperty=function(e){return'"'+e+'"'},e}();t.JSONIntellisense=a}),define("vs/languages/json/common/contributions/projectJSONContribution",["require","exports","vs/base/common/winjs.base","vs/nls!vs/languages/json/common/jsonWorker"],function(e,t,n,r){var o=40,i=function(){function e(e){this.requestService=e.requestService}return e.prototype.collectDefaultSuggestions=function(e,t){if("http://json.schemastore.org/project"===e){var o={version:"{{1.0.0-*}}",dependencies:{},frameworks:{dnx451:{},dnxcore50:{}}};t.add({type:"type",label:r.localize("vs_languages_json_common_contributions_projectJSONContribution",0),codeSnippet:JSON.stringify(o,null,"	"),documentationLabel:""})}return n.Promise.as(0)},e.prototype.collectPropertySuggestions=function(e,t,i,s,a){if("nugget-packages"===e){var c;return c=t.length>0?"https://www.nuget.org/api/v2/Packages?$filter=Id%20ge%20'"+encodeURIComponent(t)+"'%20and%20Id%20lt%20'"+encodeURIComponent(t+"z")+"'%20and%20IsAbsoluteLatestVersion%20eq%20true&$select=Id,Version,Description&$format=json&$top="+o:"https://www.nuget.org/api/v2/Packages?$filter=IsAbsoluteLatestVersion%20eq%20true&$orderby=DownloadCount%20desc&$top="+o+"&$select=Id,Version,DownloadCount,Description&$format=json",this.requestService.makeRequest({url:c}).then(function(e){if(200!==e.status)return a.error(r.localize("vs_languages_json_common_contributions_projectJSONContribution",1,e.responseText)),0;try{var t=JSON.parse(e.responseText);if(Array.isArray(t.d)){for(var n=t.d,c=0;c<n.length;c++){var l=n[c],u=l.Id,d=l.Version;if(u){var h=l.Description,p=l.Version,m=JSON.stringify(u);i&&(m+=': "{{'+d+'}}"',s||(m+=",")),a.add({type:"property",label:u,codeSnippet:m,typeLabel:p,documentationLabel:h})}}n.length===o&&a.setAsIncomplete()}}catch(f){}},function(e){return a.error(r.localize("vs_languages_json_common_contributions_projectJSONContribution",2,e.responseText)),0})}return n.Promise.as(0)},e.prototype.collectValueSuggestions=function(e,t,i){if("nugget-packages"===e){var s="https://www.myget.org/F/aspnetrelease/api/v2/Packages?$filter=Id%20eq%20'"+encodeURIComponent(t)+"'&$select=Version,IsAbsoluteLatestVersion&$format=json&$top="+o;return this.requestService.makeRequest({url:s}).then(function(e){try{var t=JSON.parse(e.responseText);if(Array.isArray(t.d)){for(var n=t.d,s=0;s<n.length;s++){var a=n[s],c=a.Version;if(c){var l=JSON.stringify(c),u="true"===a.IsAbsoluteLatestVersion,d=l,h="";u&&(h=r.localize("vs_languages_json_common_contributions_projectJSONContribution",3)),i.add({type:"class",label:d,codeSnippet:l,documentationLabel:h})}}n.length===o&&i.setAsIncomplete()}}catch(p){}return 0},function(){return 0})}return n.Promise.as(0)},e.prototype.getInfoContribution=function(e,t){if("nugget-package"===e){var n=[];n.push({className:"type",text:r.localize("vs_languages_json_common_contributions_projectJSONContribution",4,t)});var o="https://www.myget.org/F/aspnetrelease/api/v2/Packages?$filter=Id%20eq%20'"+encodeURIComponent(t)+"'%20and%20IsAbsoluteLatestVersion%20eq%20true&$select=Version,Description&$format=json&$top=5";return this.requestService.makeRequest({url:o}).then(function(e){var t=e.responseText;if(t)try{var o=JSON.parse(t);if(o.d&&o.d[0]){var i=o.d[0];i.Description&&n.push({className:"documentation",text:i.Description}),i.Version&&n.push({className:"documentation",text:r.localize("vs_languages_json_common_contributions_projectJSONContribution",5,i.Version)})}}catch(s){}return n},function(){return n})}return null},e}();t.ProjectJSONContribution=i}),define("vs/languages/json/common/contributions/packageJSONContribution",["require","exports","vs/base/common/winjs.base","vs/nls!vs/languages/json/common/jsonWorker"],function(e,t,n,r){var o=40,i=function(){function e(e){this.mostDependedOn=["lodash","async","underscore","request","commander","express","debug","chalk","colors","q","coffee-script","mkdirp","optimist","through2","yeoman-generator","moment","bluebird","glob","gulp-util","minimist","cheerio","jade","redis","node-uuid","socket","io","uglify-js","winston","through","fs-extra","handlebars","body-parser","rimraf","mime","semver","mongodb","jquery","grunt","connect","yosay","underscore","string","xml2js","ejs","mongoose","marked","extend","mocha","superagent","js-yaml","xtend","shelljs","gulp","yargs","browserify","minimatch","react","less","prompt","inquirer","ws","event-stream","inherits","mysql","esprima","jsdom","stylus","when","readable-stream","aws-sdk","concat-stream","chai","promise","wrench"],this.requestService=e.requestService}return e.prototype.collectDefaultSuggestions=function(e,t){if("http://json.schemastore.org/package"===e){var o={name:"{{name}}",description:"{{description}}",author:"{{author}}",version:"{{1.0.0}}",main:"{{pathToMain}}",dependencies:{}};t.add({type:"module",label:r.localize("vs_languages_json_common_contributions_packageJSONContribution",0),codeSnippet:JSON.stringify(o,null,"	"),documentationLabel:""})}return n.Promise.as(0)},e.prototype.collectPropertySuggestions=function(e,t,i,s,a){if("npm-packages"===e){var c;if(t.length>0)return c="https://skimdb.npmjs.com/registry/_design/app/_view/browseAll?group_level=1&limit="+o+"&start_key=%5B%22"+encodeURIComponent(t)+"%22%5D&end_key=%5B%22"+encodeURIComponent(t+"z")+"%22,%7B%7D%5D",this.requestService.makeRequest({url:c}).then(function(e){if(200!==e.status)return a.error(r.localize("vs_languages_json_common_contributions_packageJSONContribution",1,e.responseText)),0;try{var t=JSON.parse(e.responseText);if(t&&Array.isArray(t.rows)){for(var n=t.rows,c=0;c<n.length;c++){var l=n[c].key;if(Array.isArray(l)&&l.length>0){var u=l[0],d=JSON.stringify(u);i&&(d+=': "{{*}}"',s||(d+=",")),a.add({type:"property",label:u,codeSnippet:d,documentationLabel:""})}}n.length===o&&a.setAsIncomplete()}}catch(h){}},function(e){return a.error(r.localize("vs_languages_json_common_contributions_packageJSONContribution",2,e.responseText)),0});this.mostDependedOn.forEach(function(e){var t=JSON.stringify(e);i&&(t+=': "{{*}}"',s||(t+=",")),a.add({type:"property",label:e,codeSnippet:t,documentationLabel:""})}),a.setAsIncomplete()}return n.Promise.as(0)},e.prototype.collectValueSuggestions=function(e,t,o){if("npm-packages"===e){var i="http://registry.npmjs.org/"+encodeURIComponent(t)+"/latest";return this.requestService.makeRequest({url:i}).then(function(e){try{var t=JSON.parse(e.responseText);if(t&&t.version){var n=t.version,i=JSON.stringify(n);o.add({type:"class",label:i,codeSnippet:i,documentationLabel:r.localize("vs_languages_json_common_contributions_packageJSONContribution",3)}),i=JSON.stringify("^"+n),o.add({type:"class",label:i,codeSnippet:i,documentationLabel:r.localize("vs_languages_json_common_contributions_packageJSONContribution",4)}),i=JSON.stringify("~"+n),o.add({type:"class",label:i,codeSnippet:i,documentationLabel:r.localize("vs_languages_json_common_contributions_packageJSONContribution",5)})}}catch(s){}return 0},function(){return 0})}return n.Promise.as(0)},e.prototype.getInfoContribution=function(e,t){if("npm-package"===e){var n=[];n.push({className:"type",text:r.localize("vs_languages_json_common_contributions_packageJSONContribution",6,t)});var o="http://registry.npmjs.org/"+encodeURIComponent(t)+"/latest";return this.requestService.makeRequest({url:o}).then(function(e){try{var t=JSON.parse(e.responseText);t&&(t.description&&n.push({className:"documentation",text:t.description}),t.version&&n.push({className:"documentation",text:r.localize("vs_languages_json_common_contributions_packageJSONContribution",7,t.version)}))}catch(o){}return n},function(){return n})}return null},e}();t.PackageJSONContribution=i}),define("vs/languages/json/common/contributions/bowerJSONContribution",["require","exports","vs/base/common/strings","vs/base/common/winjs.base","vs/nls!vs/languages/json/common/jsonWorker"],function(e,t,n,r,o){var i=function(){function e(e){this.topRanked=["twitter","bootstrap","angular-1.1.6","angular-latest","angulerjs","d3","myjquery","jq","abcdef1234567890","jQuery","jquery-1.11.1","jquery","sushi-vanilla-x-data","font-awsome","Font-Awesome","font-awesome","fontawesome","html5-boilerplate","impress.js","homebrew","backbone","moment1","momentjs","moment","linux","animate.css","animate-css","reveal.js","jquery-file-upload","blueimp-file-upload","threejs","express","chosen","normalize-css","normalize.css","semantic","semantic-ui","Semantic-UI","modernizr","underscore","underscore1","material-design-icons","ionic","chartjs","Chart.js","nnnick-chartjs","select2-ng","select2-dist","phantom","skrollr","scrollr","less.js","leancss","parser-lib","hui","bootstrap-languages","async","gulp","jquery-pjax","coffeescript","hammer.js","ace","leaflet","jquery-mobile","sweetalert","typeahead.js","soup","typehead.js","sails","codeigniter2"],this.requestService=e.requestService}return e.prototype.collectDefaultSuggestions=function(e,t){if("http://json.schemastore.org/bower"===e){var n={name:"{{name}}",description:"{{description}}",author:"{{author}}",version:"{{1.0.0}}",main:"{{pathToMain}}",dependencies:{}};t.add({type:"type",label:o.localize("vs_languages_json_common_contributions_bowerJSONContribution",0),codeSnippet:JSON.stringify(n,null,"	"),documentationLabel:""})}return r.Promise.as(0)},e.prototype.collectPropertySuggestions=function(e,t,n,i,s){if("bower-packages"===e){if(t.length>0){var a="https://bower.herokuapp.com/packages/search/"+encodeURIComponent(t);return this.requestService.makeRequest({url:a}).then(function(e){if(200!==e.status)return s.error(o.localize("vs_languages_json_common_contributions_bowerJSONContribution",1,e.responseText)),0;try{var t=JSON.parse(e.responseText);if(Array.isArray(t)){for(var r=t,a=0;a<r.length;a++){var c=r[a].name,l=r[a].description||"",u=JSON.stringify(c);n&&(u+=': "{{*}}"',i||(u+=",")),s.add({type:"property",label:c,codeSnippet:u,documentationLabel:l})}s.setAsIncomplete()}}catch(d){}},function(e){return s.error(o.localize("vs_languages_json_common_contributions_bowerJSONContribution",2,e.responseText)),0})}this.topRanked.forEach(function(e){var t=JSON.stringify(e);n&&(t+=': "{{*}}"',i||(t+=",")),s.add({type:"property",label:e,codeSnippet:t,documentationLabel:""})}),s.setAsIncomplete()}return r.Promise.as(0)},e.prototype.collectValueSuggestions=function(){return r.Promise.as(0)},e.prototype.getInfoContribution=function(e,t){if("bower-package"===e){var r=[];r.push({className:"type",text:o.localize("vs_languages_json_common_contributions_bowerJSONContribution",3,t)});var i="https://bower.herokuapp.com/packages/"+encodeURIComponent(t);return this.requestService.makeRequest({url:i}).then(function(e){try{var t=JSON.parse(e.responseText);if(t&&t.url){var o=t.url;n.startsWith(o,"git://")&&(o=o.substring(6)),n.endsWith(o,".git")&&(o=o.substring(0,o.length-4)),r.push({className:"documentation",text:o})}}catch(i){}return r},function(){return r})}return null},e}();t.BowerJSONContribution=i}),define("vs/languages/json/common/contributions/globPatternContribution",["require","exports","vs/base/common/winjs.base","vs/nls!vs/languages/json/common/jsonWorker"],function(e,t,n,r){var o=[{type:"value",label:r.localize("vs_languages_json_common_contributions_globPatternContribution",0),codeSnippet:'"**/*.{{extension}}": true',documentationLabel:r.localize("vs_languages_json_common_contributions_globPatternContribution",1)},{type:"value",label:r.localize("vs_languages_json_common_contributions_globPatternContribution",2),codeSnippet:'"**/*.{ext1,ext2,ext3}": true',documentationLabel:r.localize("vs_languages_json_common_contributions_globPatternContribution",3)},{type:"value",label:r.localize("vs_languages_json_common_contributions_globPatternContribution",4),codeSnippet:'"**/*.{{source-extension}}": { "when": "$(basename).{{target-extension}}" }',documentationLabel:r.localize("vs_languages_json_common_contributions_globPatternContribution",5)},{type:"value",label:r.localize("vs_languages_json_common_contributions_globPatternContribution",6),codeSnippet:'"{{name}}": true',documentationLabel:r.localize("vs_languages_json_common_contributions_globPatternContribution",7)},{type:"value",label:r.localize("vs_languages_json_common_contributions_globPatternContribution",8),codeSnippet:'"{folder1,folder2,folder3}": true',documentationLabel:r.localize("vs_languages_json_common_contributions_globPatternContribution",9)},{type:"value",label:r.localize("vs_languages_json_common_contributions_globPatternContribution",10),codeSnippet:'"**/{{name}}": true',documentationLabel:r.localize("vs_languages_json_common_contributions_globPatternContribution",11)}],i=[{type:"value",label:r.localize("vs_languages_json_common_contributions_globPatternContribution",12),codeSnippet:"true",documentationLabel:r.localize("vs_languages_json_common_contributions_globPatternContribution",13)},{type:"value",label:r.localize("vs_languages_json_common_contributions_globPatternContribution",14),codeSnippet:"false",documentationLabel:r.localize("vs_languages_json_common_contributions_globPatternContribution",15)},{type:"value",label:r.localize("vs_languages_json_common_contributions_globPatternContribution",16),codeSnippet:'{ "when": "$(basename).{{extension}}" }',documentationLabel:r.localize("vs_languages_json_common_contributions_globPatternContribution",17)}],s=function(){function e(){}return e.prototype.collectDefaultSuggestions=function(){return n.Promise.as(0)},e.prototype.collectPropertySuggestions=function(e,t,r,i,s){return"glob-pattern"===e&&o.forEach(function(e){return s.add(e)}),n.Promise.as(0)},e.prototype.collectValueSuggestions=function(e,t,r){return"glob-pattern"===e&&i.forEach(function(e){return r.add(e)}),n.Promise.as(0)},e.prototype.getInfoContribution=function(){return null},e}();t.GlobPatternContribution=s});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/json/common/jsonWorker",["require","exports","vs/base/common/severity","vs/editor/common/modes/abstractModeWorker","./parser/jsonParser","vs/languages/json/common/features/jsonFormatter","./jsonSchemaService","./jsonIntellisense","vs/base/common/winjs.base","vs/base/common/strings","./contributions/projectJSONContribution","vs/editor/common/modes/supports","./contributions/packageJSONContribution","./contributions/bowerJSONContribution","./contributions/globPatternContribution","vs/base/common/errors"],function(e,t,n,r,o,i,s,a,c,l,u,d,h,p,m,f){var g=function(e){function t(t,n,r){e.call(this,t,n,r),this.jsonMode=n,this.requestService=t.requestService,this.contextService=t.contextService,this.schemaService=new s.JSONSchemaService(t),this.contributions=[t.instantiationService.createInstance(u.ProjectJSONContribution),t.instantiationService.createInstance(h.PackageJSONContribution),t.instantiationService.createInstance(p.BowerJSONContribution),t.instantiationService.createInstance(m.GlobPatternContribution)],this.jsonIntellisense=new a.JSONIntellisense({schemaService:this.schemaService,requestService:this.requestService},this.contributions)}return __extends(t,e),t.prototype._createInPlaceReplaceSupport=function(){return new d.WorkerInplaceReplaceSupport(this.resourceService,this)},t.prototype._doConfigure=function(e){var t=this;return e&&e.schemas&&(this.schemaService.clearExternalSchemas(),e.schemas.forEach(function(e){if(e.url&&(e.fileMatch||e.schema)){var n=e.url;if(!l.startsWith(n,"http://")&&!l.startsWith(n,"https://")&&!l.startsWith(n,"file://")){var r=t.contextService.toResource(n);r&&(n=r.toString())}var o=null;if(e.fileMatch){o=[];for(var i=0;i<e.fileMatch.length;i++)try{o.push(new RegExp(l.convertSimple2RegExpPattern(e.fileMatch[i])))}catch(s){}}n&&t.schemaService.registerExternalSchema(n,o,e.schema)}else if(e.filePattern&&e.schemaPath){var n=t.contextService.toResource(e.schemaPath).toString(),o=[];try{o.push(new RegExp(e.filePattern))}catch(s){}t.schemaService.registerExternalSchema(n,o)}})),c.TPromise.as(!0)},t.prototype.setConfigurationSchemas=function(e){return this.schemaService.setConfigurationSchemas(e),c.TPromise.as(!0)},t.prototype.doValidate=function(e){var t=this,r=this.resourceService.get(e),i=new o.JSONParser,s=r.getValue();if(0!==s.length){var a=i.parse(s);this.schemaService.getSchemaForResource(e.toString(),a).then(function(o){if(o)if(o.loadError&&a.root){var i="object"===a.root.type?a.root.getFirstProperty("$schema"):null;if(i){var s=i.value||i;a.warnings.push({location:{start:s.start,end:s.end},message:o.loadError})}else a.warnings.push({location:{start:a.root.start,end:a.root.start+1},message:o.loadError})}else a.validate(o.schema);var c=a.errors.concat(a.warnings).map(function(e,t){var o=r.getPositionFromOffset(e.location.start),i=r.getPositionFromOffset(e.location.end);return{message:e.message,severity:t>=a.errors.length?n.Warning:n.Error,startLineNumber:o.lineNumber,startColumn:o.column,endLineNumber:i.lineNumber,endColumn:i.column}});t.markerService.changeOne(t._getMode().getId(),e,c)})}},t.prototype.doSuggest=function(e,t){var n=this.resourceService.get(e);return this.jsonIntellisense.doSuggest(e,n,t)},t.prototype.computeInfo=function(e,t){var n=this,r=this.resourceService.get(e),i=new o.JSONParser,s=i.parse(r.getValue()),a=r.getOffsetFromPosition(t),l=s.getNodeFromOffset(a),u=l;if(l&&"string"===l.type){var d=l;if(d.isKey){var h=l.parent;l=h.value}}return l?this.schemaService.getSchemaForResource(e.toString(),s).then(function(e){if(e){var t=[];s.validate(e.schema,t,l.start);var o=null,i=null;if(t.every(function(e){return e.node===l&&!e.inverted&&e.schema&&(o=o||e.schema.description,i=i||e.schema.id),!0}),i&&l.name)for(var a=n.contributions.length-1;a>=0;a--){var c=n.contributions[a],d=c.getInfoContribution(i,l.name);if(d)return d.then(function(e){return n.createInfoResult(e,u,r)})}if(o){var h=[{className:"documentation",text:o}];return n.createInfoResult(h,u,r)}}return null}):c.Promise.as(null)},t.prototype.createInfoResult=function(e,t,n){var r=n.getRangeFromOffsetAndLength(t.start,t.end-t.start),o={value:"",htmlContent:e,className:"typeInfo json",range:r};return o},t.prototype.getOutline=function(e){function t(e,r){if("array"===r.type)r.items.forEach(function(n){t(e,n)});else if("object"===r.type){var o=r;o.properties.forEach(function(r){var o=n.getRangeFromOffsetAndLength(r.start,r.end-r.start),i=r.value;if(i){var s=t([],i),a="object"===i.type?"module":i.type;e.push({label:r.key.getValue(),icon:a,type:i.type,range:o,children:s})}})}return e}var n=this.resourceService.get(e),r=new o.JSONParser,i=r.parse(n.getValue()),s=i.root;if(!s)return c.Promise.as(null);var a=e.toString();if(("inmemory:/.keybindings/defaults.json"===a||l.endsWith(a.toLowerCase(),"/user/keybindings.json"))&&"array"===s.type){var u=[];return s.items.forEach(function(e){if("object"===e.type){var t=e.getFirstProperty("key");if(t&&t.value){var r=n.getRangeFromOffsetAndLength(e.start,e.end-e.start);u.push({label:t.value.getValue(),icon:"function",type:"string",range:r,children:[]})}}}),c.Promise.as(u)}var u=t([],s);return c.Promise.as(u)},t.prototype.textReplace=function(e,t){return d.ReplaceSupport.valueSetReplace(["true","false"],e,t)},t.prototype.format=function(e,t,n){var r=this.resourceService.get(e);return c.TPromise.as(i.format(r,t,n))},t.prototype.navigateValueSetFallback=function(e,t,n){var r=this,i=this.resourceService.get(e),s=i.getOffsetFromPosition({lineNumber:t.startLineNumber,column:t.startColumn}),a=new o.JSONParser,c=new o.JSONDocumentConfig;c.ignoreDanglingComma=!0;var u=a.parse(i.getValue(),c),d=u.getNodeFromOffsetEndInclusive(s);return!d||"string"!==d.type&&"number"!==d.type&&"boolean"!==d.type&&"null"!==d.type?null:this.schemaService.getSchemaForResource(e.toString(),u).then(function(e){if(e){var t=[],o={},s={add:function(e){o[e.label]||(o[e.label]=!0,t.push(e))},setAsIncomplete:function(){},error:function(e){f.onUnexpectedError(e)}};return r.jsonIntellisense.getValueSuggestions(e,u,d.parent,d.start,s).then(function(){for(var e=i.getRangeFromOffsetAndLength(d.start,d.end-d.start),r=i.getValueInRange(e),o=0,s=t.length;s>o;o++)if(l.equalsIgnoreCase(t[o].label,r)){var a=o;return n?a=(o+1)%s:(a=o-1,0>a&&(a=s-1)),{value:t[a].label,range:e}}return null})}})},t}(r.AbstractModeWorker);t.JSONWorker=g});