/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/less/common/parser/lessScanner",["require","exports","vs/languages/css/common/parser/cssScanner"],function(e,t,n){var r=("%".charCodeAt(0),"(".charCodeAt(0),"/".charCodeAt(0)),o="\n".charCodeAt(0),i="\r".charCodeAt(0),s="\f".charCodeAt(0),a="`".charCodeAt(0),c=".".charCodeAt(0),l=n.TokenType.CustomToken;t.Ellipsis=l++;var u=function(e){function l(){e.apply(this,arguments)}return __extends(l,e),l.prototype.scan=function(r){void 0===r&&(r=!0);var o={type:void 0,text:void 0,offset:this.stream.pos(),len:0};if(this.lessComment())return this.ignoreComment?this.scan(r):this.finishToken(o,n.TokenType.SingleLineComment);var i=this.escapedJavaScript();return null!==i?this.finishToken(o,i):this.stream.advanceIfChars([c,c,c])?this.finishToken(o,t.Ellipsis):e.prototype.scan.call(this,r)},l.prototype.lessComment=function(){return this.stream.advanceIfChars([r,r])?(this.stream.advanceWhileChar(function(e){switch(e){case o:case i:case s:return!1;default:return!0}}),!0):!1},l.prototype.escapedJavaScript=function(){var e=this.stream.peekChar();return e===a?(this.stream.advance(1),this.stream.advanceWhileChar(function(e){return e!==a}),this.stream.advanceIfChar(a)?n.TokenType.EscapedJavaScript:n.TokenType.BadEscapedJavaScript):null},l}(n.Scanner);t.LessScanner=u});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/less/common/parser/lessParser",["require","exports","./lessScanner","vs/languages/css/common/parser/cssScanner","vs/languages/css/common/parser/cssParser","vs/languages/css/common/parser/cssNodes","vs/languages/css/common/parser/cssErrors"],function(e,t,n,r,o,i,s){var a=function(e){function t(){e.call(this,new n.LessScanner)}return __extends(t,e),t.prototype._parseStylesheetStatement=function(){return this._tryParseMixinDeclaration()||e.prototype._parseStylesheetStatement.call(this)||this._parseVariableDeclaration()},t.prototype._parseImport=function(){var e=this.create(i.Import);if(!this.accept(r.TokenType.AtKeyword,"@import")&&!this.accept(r.TokenType.AtKeyword,"@import-once"))return null;if(this.accept(r.TokenType.ParenthesisL)){if(!this.accept(r.TokenType.Ident))return this.finish(e,s.ParseError.IdentifierExpected,[r.TokenType.SemiColon]);if(!this.accept(r.TokenType.ParenthesisR))return this.finish(e,s.ParseError.RightParenthesisExpected,[r.TokenType.SemiColon])}return this.accept(r.TokenType.URI)||this.accept(r.TokenType.String)?(e.setMedialist(this._parseMediaList()),this.finish(e)):this.finish(e,s.ParseError.URIOrStringExpected,[r.TokenType.SemiColon])},t.prototype._parseVariableDeclaration=function(e){void 0===e&&(e=[]);var t=this.create(i.VariableDeclaration),n=this.mark();return t.setVariable(this._parseVariable())?this.accept(r.TokenType.Colon,":")?(t.colonPosition=this.prevToken.offset,t.setValue(this._parseExpr())?this.finish(t):this.finish(t,s.ParseError.VariableValueExpected,[],e)):(this.restoreAtMark(n),null):null},t.prototype._parseVariable=function(){for(var e=this.create(i.Variable),t=this.mark();this.accept(r.TokenType.Delim,"@");)if(this.hasWhitespace())return this.restoreAtMark(t),null;return this.accept(r.TokenType.AtKeyword)?e:(this.restoreAtMark(t),null)},t.prototype._parseTerm=function(){var t=e.prototype._parseTerm.call(this);return t?t:(t=this.create(i.Term),t.setExpression(this._parseVariable())||t.setExpression(this._parseEscaped())||t.setExpression(this._parseOperation())?this.finish(t):null)},t.prototype._parseEscaped=function(){var e=this.createNode(i.NodeType.EscapedValue);return this.accept(r.TokenType.EscapedJavaScript)||this.accept(r.TokenType.BadEscapedJavaScript)?this.finish(e):this.accept(r.TokenType.Delim,"~")?this.finish(e,this.accept(r.TokenType.String)?null:s.ParseError.TermExpected):null},t.prototype._parseOperation=function(){var e=this.create(i.Node);return this.accept(r.TokenType.ParenthesisL)?(e.addChild(this._parseExpr()),this.accept(r.TokenType.ParenthesisR)?this.finish(e):this.finish(e,s.ParseError.RightParenthesisExpected)):null},t.prototype._parseOperator=function(){var t=this._parseGuardOperator();return t?t:e.prototype._parseOperator.call(this)},t.prototype._parseGuardOperator=function(){var e=this.createNode(i.NodeType.Operator);return this.accept(r.TokenType.Delim,">")?(this.accept(r.TokenType.Delim,"="),e):this.accept(r.TokenType.Delim,"=")?(this.accept(r.TokenType.Delim,"<"),e):this.accept(r.TokenType.Delim,"<")?e:null},t.prototype._parseRuleSetDeclaration=function(){return this.peek(r.TokenType.AtKeyword)?this._parseKeyframe()||this._parseMedia()||this._parseVariableDeclaration():this._tryParseMixinDeclaration()||this._tryParseRuleset(!0)||this._parseMixinReference()||this._parseExtend()||this._parseDeclaration()},t.prototype._parseSimpleSelectorBody=function(){return this._parseSelectorCombinator()||e.prototype._parseSimpleSelectorBody.call(this)},t.prototype._parseSelectorCombinator=function(){var e=this.createNode(i.NodeType.SelectorCombinator);if(this.accept(r.TokenType.Delim,"&")){for(;!this.hasWhitespace()&&(this.accept(r.TokenType.Delim,"-")||e.addChild(this._parseIdent())||this.accept(r.TokenType.Delim,"&")););return this.finish(e)}return null},t.prototype._parseSelectorIdent=function(){return this._parseIdent()||this._parseSelectorInterpolation()},t.prototype._parseSelectorInterpolation=function(){var e=this.createNode(i.NodeType.SelectorInterpolation);return this.accept(r.TokenType.Delim,"~")?this.hasWhitespace()||!this.accept(r.TokenType.String)&&!this.accept(r.TokenType.BadString)?this.finish(e,s.ParseError.StringLiteralExpected):this.finish(e):this.accept(r.TokenType.Delim,"@")?this.hasWhitespace()||!this.accept(r.TokenType.CurlyL)?this.finish(e,s.ParseError.LeftCurlyExpected):e.addChild(this._parseIdent())?this.accept(r.TokenType.CurlyR)?this.finish(e):this.finish(e,s.ParseError.RightCurlyExpected):this.finish(e,s.ParseError.IdentifierExpected):null},t.prototype._tryParseMixinDeclaration=function(){if(!this.peek(r.TokenType.Delim,"."))return null;var e=this.mark(),t=this.create(i.MixinDeclaration);if(!t.setIdentifier(this._parseMixinDeclarationIdentifier())||!this.accept(r.TokenType.ParenthesisL))return this.restoreAtMark(e),null;if(t.getParameters().addChild(this._parseMixinParameter()))for(;this.accept(r.TokenType.Comma)||this.accept(r.TokenType.SemiColon);)if(!t.getParameters().addChild(this._parseMixinParameter()))return this.finish(t,s.ParseError.IdentifierExpected);return this.accept(r.TokenType.ParenthesisR)?(t.setGuard(this._parseGuard()),this.peek(r.TokenType.CurlyL)?this._parseBody(t,this._parseRuleSetDeclaration.bind(this)):(this.restoreAtMark(e),null)):this.finish(t,s.ParseError.RightParenthesisExpected)},t.prototype._parseMixinDeclarationIdentifier=function(){var e=this.create(i.Identifier);return this.consumeToken(),this.hasWhitespace()||!this.accept(r.TokenType.Ident)?null:(e.referenceTypes=[i.ReferenceType.Mixin],this.finish(e))},t.prototype._parseExtend=function(){if(!this.peek(r.TokenType.Delim,"&"))return null;var e=this.mark(),t=this.create(i.ExtendsReference);return this.consumeToken(),!this.hasWhitespace()&&this.accept(r.TokenType.Colon)&&this.accept(r.TokenType.Ident,"extend")?this.accept(r.TokenType.ParenthesisL)?t.setSelector(this._parseSimpleSelector())?this.accept(r.TokenType.ParenthesisR)?this.finish(t):this.finish(t,s.ParseError.RightParenthesisExpected):this.finish(t,s.ParseError.SelectorExpected):this.finish(t,s.ParseError.LeftParenthesisExpected):(this.restoreAtMark(e),null)},t.prototype._parseMixinReference=function(){if(!this.peek(r.TokenType.Delim,"."))return null;var e=this.create(i.MixinReference),t=this.create(i.Identifier);if(this.consumeToken(),this.hasWhitespace()||!this.accept(r.TokenType.Ident))return this.finish(e,s.ParseError.IdentifierExpected);if(e.setIdentifier(this.finish(t)),!this.hasWhitespace()&&this.accept(r.TokenType.ParenthesisL)){if(e.getArguments().addChild(this._parseFunctionArgument()))for(;this.accept(r.TokenType.Comma)||this.accept(r.TokenType.SemiColon);)if(!e.getArguments().addChild(this._parseExpr()))return this.finish(e,s.ParseError.ExpressionExpected);if(!this.accept(r.TokenType.ParenthesisR))return this.finish(e,s.ParseError.RightParenthesisExpected);t.referenceTypes=[i.ReferenceType.Mixin]}else t.referenceTypes=[i.ReferenceType.Mixin,i.ReferenceType.Rule];return e.addChild(this._parsePrio()),this.finish(e)},t.prototype._parseMixinParameter=function(){var e=this.create(i.FunctionParameter);if(this.peek(r.TokenType.AtKeyword,"@rest")){var t=this.create(i.Node);return this.consumeToken(),this.accept(n.Ellipsis)?(e.setIdentifier(this.finish(t)),this.finish(e)):this.finish(e,s.ParseError.DotExpected,[],[r.TokenType.Comma,r.TokenType.ParenthesisR])}if(this.peek(n.Ellipsis)){var o=this.create(i.Node);return this.consumeToken(),e.setIdentifier(this.finish(o)),this.finish(e)}return e.setIdentifier(this._parseVariable())&&this.accept(r.TokenType.Colon),e.setDefaultValue(this._parseExpr(!0)),this.finish(e)},t.prototype._parseGuard=function(){var e=this.create(i.LessGuard);if(!this.accept(r.TokenType.Ident,"when"))return null;if(e.isNegated=this.accept(r.TokenType.Ident,"not"),!e.getConditions().addChild(this._parseGuardCondition()))return this.finish(e,s.ParseError.ConditionExpected);for(;this.accept(r.TokenType.Ident,"and")||this.accept(r.TokenType.Comma,",");)if(!e.getConditions().addChild(this._parseGuardCondition()))return this.finish(e,s.ParseError.ConditionExpected);return this.finish(e)},t.prototype._parseGuardCondition=function(){var e=this.create(i.GuardCondition);return this.accept(r.TokenType.ParenthesisL)?(!e.addChild(this._parseExpr()),this.accept(r.TokenType.ParenthesisR)?this.finish(e):this.finish(e,s.ParseError.RightParenthesisExpected)):null},t.prototype._parseFunctionIdentifier=function(){if(this.peek(r.TokenType.Delim,"%")){var t=this.create(i.Identifier);return t.referenceTypes=[i.ReferenceType.Function],this.consumeToken(),this.finish(t)}return e.prototype._parseFunctionIdentifier.call(this)},t}(o.Parser);t.LessParser=a});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/less/common/services/intelliSense",["require","exports","vs/languages/css/common/services/intelliSense","vs/nls!vs/languages/less/common/lessWorker"],function(e,t,n,r){var o=function(e){function t(){e.call(this,"@")}return __extends(t,e),t.prototype.createFunctionProposals=function(e,t){return e.forEach(function(e){t.push({label:e.name,typeLabel:e.example,documentationLabel:e.description,codeSnippet:e.name+"({{}})",type:"function"})}),t},t.prototype.getTermProposals=function(n){return this.createFunctionProposals(t.builtInProposals,n),e.prototype.getTermProposals.call(this,n)},t.prototype.getColorProposals=function(n,r){return this.createFunctionProposals(t.colorProposals,r),e.prototype.getColorProposals.call(this,n,r)},t.builtInProposals=[{name:"escape",example:"escape(@string);",description:r.localize("vs_languages_less_common_services_intelliSense",0)},{name:"e",example:"e(@string);",description:r.localize("vs_languages_less_common_services_intelliSense",1)},{name:"replace",example:"replace(@string, @pattern, @replacement[, @flags]);",description:r.localize("vs_languages_less_common_services_intelliSense",2)},{name:"unit",example:"unit(@dimension, [@unit: '']);",description:r.localize("vs_languages_less_common_services_intelliSense",3)},{name:"color",example:"color(@string);",description:r.localize("vs_languages_less_common_services_intelliSense",4)},{name:"convert",example:"convert(@value, unit);",description:r.localize("vs_languages_less_common_services_intelliSense",5)},{name:"data-uri",example:"data-uri([mimetype,] url);",description:r.localize("vs_languages_less_common_services_intelliSense",6)},{name:"length",example:"length(@list);",description:r.localize("vs_languages_less_common_services_intelliSense",7)},{name:"extract",example:"extract(@list, index);",description:r.localize("vs_languages_less_common_services_intelliSense",8)},{name:"abs",description:r.localize("vs_languages_less_common_services_intelliSense",9),example:"abs(number);"},{name:"acos",description:r.localize("vs_languages_less_common_services_intelliSense",10),example:"acos(number);"},{name:"asin",description:r.localize("vs_languages_less_common_services_intelliSense",11),example:"asin(number);"},{name:"ceil",example:"ceil(@number);",description:r.localize("vs_languages_less_common_services_intelliSense",12)},{name:"cos",description:r.localize("vs_languages_less_common_services_intelliSense",13),example:"cos(number);"},{name:"floor",description:r.localize("vs_languages_less_common_services_intelliSense",14),example:"floor(@number);"},{name:"percentage",description:r.localize("vs_languages_less_common_services_intelliSense",15),example:"percentage(@number);"},{name:"round",description:r.localize("vs_languages_less_common_services_intelliSense",16),example:"round(number, [places: 0]);"},{name:"sqrt",description:r.localize("vs_languages_less_common_services_intelliSense",17),example:"sqrt(number);"},{name:"sin",description:r.localize("vs_languages_less_common_services_intelliSense",18),example:"sin(number);"},{name:"tan",description:r.localize("vs_languages_less_common_services_intelliSense",19),example:"tan(number);"},{name:"atan",description:r.localize("vs_languages_less_common_services_intelliSense",20),example:"atan(number);"},{name:"pi",description:r.localize("vs_languages_less_common_services_intelliSense",21),example:"pi();"},{name:"pow",description:r.localize("vs_languages_less_common_services_intelliSense",22),example:"pow(@base, @exponent);"},{name:"mod",description:r.localize("vs_languages_less_common_services_intelliSense",23),example:"mod(number, number);"},{name:"min",description:r.localize("vs_languages_less_common_services_intelliSense",24),example:"min(@x, @y);"},{name:"max",description:r.localize("vs_languages_less_common_services_intelliSense",25),example:"max(@x, @y);"}],t.colorProposals=[{name:"argb",example:"argb(@color);",description:r.localize("vs_languages_less_common_services_intelliSense",26)},{name:"hsl",example:"hsl(@hue, @saturation, @lightness);",description:r.localize("vs_languages_less_common_services_intelliSense",27)},{name:"hsla",example:"hsla(@hue, @saturation, @lightness, @alpha);",description:r.localize("vs_languages_less_common_services_intelliSense",28)},{name:"hsv",example:"hsv(@hue, @saturation, @value);",description:r.localize("vs_languages_less_common_services_intelliSense",29)},{name:"hsva",example:"hsva(@hue, @saturation, @value, @alpha);",description:r.localize("vs_languages_less_common_services_intelliSense",30)},{name:"hue",example:"hue(@color);",description:r.localize("vs_languages_less_common_services_intelliSense",31)},{name:"saturation",example:"saturation(@color);",description:r.localize("vs_languages_less_common_services_intelliSense",32)},{name:"lightness",example:"lightness(@color);",description:r.localize("vs_languages_less_common_services_intelliSense",33)},{name:"hsvhue",example:"hsvhue(@color);",description:r.localize("vs_languages_less_common_services_intelliSense",34)},{name:"hsvsaturation",example:"hsvsaturation(@color);",description:r.localize("vs_languages_less_common_services_intelliSense",35)},{name:"hsvvalue",example:"hsvvalue(@color);",description:r.localize("vs_languages_less_common_services_intelliSense",36)},{name:"red",example:"red(@color);",description:r.localize("vs_languages_less_common_services_intelliSense",37)},{name:"green",example:"green(@color);",description:r.localize("vs_languages_less_common_services_intelliSense",38)},{name:"blue",example:"blue(@color);",description:r.localize("vs_languages_less_common_services_intelliSense",39)},{name:"alpha",example:"alpha(@color);",description:r.localize("vs_languages_less_common_services_intelliSense",40)},{name:"luma",example:"luma(@color);",description:r.localize("vs_languages_less_common_services_intelliSense",41)},{name:"saturate",example:"saturate(@color, 10%);",description:r.localize("vs_languages_less_common_services_intelliSense",42)},{name:"desaturate",example:"desaturate(@color, 10%);",description:r.localize("vs_languages_less_common_services_intelliSense",43)},{name:"lighten",example:"lighten(@color, 10%);",description:r.localize("vs_languages_less_common_services_intelliSense",44)},{name:"darken",example:"darken(@color, 10%);",description:r.localize("vs_languages_less_common_services_intelliSense",45)},{name:"fadein",example:"fadein(@color, 10%);",description:r.localize("vs_languages_less_common_services_intelliSense",46)},{name:"fadeout",example:"fadeout(@color, 10%);",description:r.localize("vs_languages_less_common_services_intelliSense",47)},{name:"fade",example:"fade(@color, 50%);",description:r.localize("vs_languages_less_common_services_intelliSense",48)},{name:"spin",example:"spin(@color, 10);",description:r.localize("vs_languages_less_common_services_intelliSense",49)},{name:"mix",example:"mix(@color1, @color2, [@weight: 50%]);",description:r.localize("vs_languages_less_common_services_intelliSense",50)},{name:"greyscale",example:"greyscale(@color);",description:r.localize("vs_languages_less_common_services_intelliSense",51)},{name:"contrast",example:"contrast(@color1, [@darkcolor: black], [@lightcolor: white], [@threshold: 43%]);",description:r.localize("vs_languages_less_common_services_intelliSense",52)},{name:"multiply",example:"multiply(@color1, @color2);"},{name:"screen",example:"screen(@color1, @color2);"},{name:"overlay",example:"overlay(@color1, @color2);"},{name:"softlight",example:"softlight(@color1, @color2);"},{name:"hardlight",example:"hardlight(@color1, @color2);"},{name:"difference",example:"difference(@color1, @color2);"},{name:"exclusion",example:"exclusion(@color1, @color2);"},{name:"average",example:"average(@color1, @color2);"},{name:"negation",example:"negation(@color1, @color2);"}],t}(n.CSSIntellisense);t.LESSIntellisense=o});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/less/common/lessWorker",["require","exports","vs/languages/css/common/cssWorker","./parser/lessParser","./services/intelliSense"],function(e,t,n,r,o){var i=function(e){function t(t,n,r){e.call(this,t,n,r)}return __extends(t,e),t.prototype.createIntellisense=function(){return new o.LESSIntellisense},t.prototype.createParser=function(){return new r.LessParser},t}(n.CSSWorker);t.LessWorker=i});